dart_library.library('collection', null, /* Imports */[
  'dart_sdk'
], function(exports, dart_sdk) {
  'use strict';
  const core = dart_sdk.core;
  const math = dart_sdk.math;
  const collection = dart_sdk.collection;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const collection$ = Object.create(null);
  const algorithms = Object.create(null);
  const utils = Object.create(null);
  const canonicalized_map = Object.create(null);
  const comparators = Object.create(null);
  const equality = Object.create(null);
  const iterable_zip = Object.create(null);
  const priority_queue = Object.create(null);
  const queue_list = Object.create(null);
  const unmodifiable_wrappers = Object.create(null);
  const wrappers = Object.create(null);
  const typed_wrappers = Object.create(null);
  algorithms.mergeSort = function(list, opts) {
    let start = opts && 'start' in opts ? opts.start : 0;
    let end = opts && 'end' in opts ? opts.end : null;
    let compare = opts && 'compare' in opts ? opts.compare : null;
    let t = end;
    t == null ? end = list[dartx.length] : t;
    let t$ = compare;
    t$ == null ? compare = utils.defaultCompare() : t$;
    let length = dart.notNull(end) - dart.notNull(start);
    if (length < 2) return;
    if (length < dart.notNull(algorithms._MERGE_SORT_LIMIT)) {
      algorithms.insertionSort(list, {compare: compare, start: start, end: end});
      return;
    }
    let middle = dart.notNull(start) + (dart.notNull(end) - dart.notNull(start) >> 1);
    let firstLength = middle - dart.notNull(start);
    let secondLength = dart.notNull(end) - middle;
    let scratchSpace = core.List.new(secondLength);
    algorithms._mergeSort(list, compare, middle, end, scratchSpace, 0);
    let firstTarget = dart.notNull(end) - firstLength;
    algorithms._mergeSort(list, compare, start, middle, list, firstTarget);
    algorithms._merge(compare, list, firstTarget, end, scratchSpace, 0, secondLength, list, start);
  };
  dart.fn(algorithms.mergeSort, dart.void, [core.List], {start: core.int, end: core.int, compare: dart.functionType(core.int, [dart.dynamic, dart.dynamic])});
  collection$.mergeSort = algorithms.mergeSort;
  algorithms.lowerBound = function(sortedList, value, opts) {
    let compare = opts && 'compare' in opts ? opts.compare : null;
    let t = compare;
    t == null ? compare = utils.defaultCompare() : t;
    let min = 0;
    let max = sortedList[dartx.length];
    while (min < dart.notNull(max)) {
      let mid = min + (dart.notNull(max) - min >> 1);
      let element = sortedList[dartx.get](mid);
      let comp = compare(element, value);
      if (dart.notNull(comp) < 0) {
        min = mid + 1;
      } else {
        max = mid;
      }
    }
    return min;
  };
  dart.fn(algorithms.lowerBound, core.int, [core.List, dart.dynamic], {compare: dart.functionType(core.int, [dart.dynamic, dart.dynamic])});
  collection$.lowerBound = algorithms.lowerBound;
  algorithms.shuffle = function(list, start, end) {
    if (start === void 0) start = 0;
    if (end === void 0) end = null;
    let random = math.Random.new();
    if (end == null) end = list[dartx.length];
    let length = dart.notNull(end) - dart.notNull(start);
    while (length > 1) {
      let pos = random.nextInt(length);
      length--;
      let tmp1 = list[dartx.get](dart.notNull(start) + dart.notNull(pos));
      list[dartx.set](dart.notNull(start) + dart.notNull(pos), list[dartx.get](dart.notNull(start) + length));
      list[dartx.set](dart.notNull(start) + length, tmp1);
    }
  };
  dart.fn(algorithms.shuffle, dart.void, [core.List], [core.int, core.int]);
  collection$.shuffle = algorithms.shuffle;
  algorithms.binarySearch = function(sortedList, value, opts) {
    let compare = opts && 'compare' in opts ? opts.compare : null;
    let t = compare;
    t == null ? compare = utils.defaultCompare() : t;
    let min = 0;
    let max = sortedList[dartx.length];
    while (min < dart.notNull(max)) {
      let mid = min + (dart.notNull(max) - min >> 1);
      let element = sortedList[dartx.get](mid);
      let comp = compare(element, value);
      if (comp == 0) return mid;
      if (dart.notNull(comp) < 0) {
        min = mid + 1;
      } else {
        max = mid;
      }
    }
    return -1;
  };
  dart.fn(algorithms.binarySearch, core.int, [core.List, dart.dynamic], {compare: dart.functionType(core.int, [dart.dynamic, dart.dynamic])});
  collection$.binarySearch = algorithms.binarySearch;
  algorithms.reverse = function(list, start, end) {
    if (start === void 0) start = 0;
    if (end === void 0) end = null;
    if (end == null) end = list[dartx.length];
    algorithms._reverse(list, start, end);
  };
  dart.fn(algorithms.reverse, dart.void, [core.List], [core.int, core.int]);
  collection$.reverse = algorithms.reverse;
  algorithms.insertionSort = function(list, opts) {
    let compare = opts && 'compare' in opts ? opts.compare : null;
    let start = opts && 'start' in opts ? opts.start : 0;
    let end = opts && 'end' in opts ? opts.end : null;
    let t = compare;
    t == null ? compare = utils.defaultCompare() : t;
    let t$ = end;
    t$ == null ? end = list[dartx.length] : t$;
    for (let pos = dart.notNull(start) + 1; pos < dart.notNull(end); pos++) {
      let min = start;
      let max = pos;
      let element = list[dartx.get](pos);
      while (dart.notNull(min) < max) {
        let mid = dart.notNull(min) + (max - dart.notNull(min) >> 1);
        let comparison = compare(element, list[dartx.get](mid));
        if (dart.notNull(comparison) < 0) {
          max = mid;
        } else {
          min = mid + 1;
        }
      }
      list[dartx.setRange](dart.notNull(min) + 1, pos + 1, list, min);
      list[dartx.set](min, element);
    }
  };
  dart.fn(algorithms.insertionSort, dart.void, [core.List], {compare: dart.functionType(core.int, [dart.dynamic, dart.dynamic]), start: core.int, end: core.int});
  collection$.insertionSort = algorithms.insertionSort;
  const _base = Symbol('_base');
  const _canonicalize = Symbol('_canonicalize');
  const _isValidKeyFn = Symbol('_isValidKeyFn');
  const _isValidKey = Symbol('_isValidKey');
  canonicalized_map.CanonicalizedMap$ = dart.generic((C, K, V) => {
    class CanonicalizedMap extends core.Object {
      CanonicalizedMap(canonicalize, opts) {
        let isValidKey = opts && 'isValidKey' in opts ? opts.isValidKey : null;
        this[_base] = core.Map$(C, utils.Pair$(K, V)).new();
        this[_canonicalize] = canonicalize;
        this[_isValidKeyFn] = isValidKey;
      }
      from(other, canonicalize, opts) {
        let isValidKey = opts && 'isValidKey' in opts ? opts.isValidKey : null;
        this[_base] = core.Map$(C, utils.Pair$(K, V)).new();
        this[_canonicalize] = canonicalize;
        this[_isValidKeyFn] = isValidKey;
        this.addAll(other);
      }
      get(key) {
        if (!dart.notNull(this[_isValidKey](key))) return null;
        let pair = this[_base][dartx.get](this[_canonicalize](dart.as(key, K)));
        return pair == null ? null : pair.last;
      }
      set(key, value) {
        (() => {
          dart.as(key, K);
          dart.as(value, V);
          if (!dart.notNull(this[_isValidKey](key))) return;
          this[_base][dartx.set](this[_canonicalize](key), new (utils.Pair$(K, V))(key, value));
        })();
        return value;
      }
      addAll(other) {
        dart.as(other, core.Map$(K, V));
        other[dartx.forEach](dart.fn((key, value) => {
          dart.as(key, K);
          dart.as(value, V);
          return this.set(key, value);
        }, V, [K, V]));
      }
      clear() {
        this[_base][dartx.clear]();
      }
      containsKey(key) {
        if (!dart.notNull(this[_isValidKey](key))) return false;
        return this[_base][dartx.containsKey](this[_canonicalize](dart.as(key, K)));
      }
      containsValue(value) {
        return this[_base][dartx.values][dartx.any](dart.fn(pair => {
          dart.as(pair, utils.Pair$(K, V));
          return dart.equals(pair.last, value);
        }, core.bool, [utils.Pair$(K, V)]));
      }
      forEach(f) {
        dart.as(f, dart.functionType(dart.void, [K, V]));
        this[_base][dartx.forEach](dart.fn((key, pair) => {
          dart.as(key, C);
          dart.as(pair, utils.Pair$(K, V));
          return f(pair.first, pair.last);
        }, dart.void, [C, utils.Pair$(K, V)]));
      }
      get isEmpty() {
        return this[_base][dartx.isEmpty];
      }
      get isNotEmpty() {
        return this[_base][dartx.isNotEmpty];
      }
      get keys() {
        return this[_base][dartx.values][dartx.map](dart.fn(pair => {
          dart.as(pair, utils.Pair$(K, V));
          return pair.first;
        }, K, [utils.Pair$(K, V)]));
      }
      get length() {
        return this[_base][dartx.length];
      }
      putIfAbsent(key, ifAbsent) {
        dart.as(key, K);
        dart.as(ifAbsent, dart.functionType(V, []));
        return this[_base][dartx.putIfAbsent](this[_canonicalize](key), dart.fn(() => new (utils.Pair$(K, V))(key, ifAbsent()), utils.Pair$(K, V), [])).last;
      }
      remove(key) {
        if (!dart.notNull(this[_isValidKey](key))) return null;
        let pair = this[_base][dartx.remove](this[_canonicalize](dart.as(key, K)));
        return pair == null ? null : pair.last;
      }
      get values() {
        return this[_base][dartx.values][dartx.map](dart.fn(pair => {
          dart.as(pair, utils.Pair$(K, V));
          return pair.last;
        }, V, [utils.Pair$(K, V)]));
      }
      toString() {
        return collection.Maps.mapToString(this);
      }
      [_isValidKey](key) {
        return (key == null || dart.is(key, K)) && (this[_isValidKeyFn] == null || dart.notNull(this[_isValidKeyFn](key)));
      }
    }
    dart.defineNamedConstructor(CanonicalizedMap, 'from');
    CanonicalizedMap[dart.implements] = () => [core.Map$(K, V)];
    dart.setSignature(CanonicalizedMap, {
      constructors: () => ({
        CanonicalizedMap: [canonicalized_map.CanonicalizedMap$(C, K, V), [dart.functionType(C, [K])], {isValidKey: dart.functionType(core.bool, [core.Object])}],
        from: [canonicalized_map.CanonicalizedMap$(C, K, V), [core.Map$(K, V), dart.functionType(C, [K])], {isValidKey: dart.functionType(core.bool, [core.Object])}]
      }),
      methods: () => ({
        get: [V, [core.Object]],
        set: [dart.void, [K, V]],
        addAll: [dart.void, [core.Map$(K, V)]],
        clear: [dart.void, []],
        containsKey: [core.bool, [core.Object]],
        containsValue: [core.bool, [core.Object]],
        forEach: [dart.void, [dart.functionType(dart.void, [K, V])]],
        putIfAbsent: [V, [K, dart.functionType(V, [])]],
        remove: [V, [core.Object]],
        [_isValidKey]: [core.bool, [core.Object]]
      })
    });
    dart.defineExtensionMembers(CanonicalizedMap, [
      'get',
      'set',
      'addAll',
      'clear',
      'containsKey',
      'containsValue',
      'forEach',
      'putIfAbsent',
      'remove',
      'isEmpty',
      'isNotEmpty',
      'keys',
      'length',
      'values'
    ]);
    return CanonicalizedMap;
  });
  canonicalized_map.CanonicalizedMap = canonicalized_map.CanonicalizedMap$();
  collection$.CanonicalizedMap$ = canonicalized_map.CanonicalizedMap$;
  collection$.CanonicalizedMap = canonicalized_map.CanonicalizedMap;
  comparators.compareAsciiUpperCase = function(a, b) {
    let defaultResult = 0;
    for (let i = 0; i < dart.notNull(a[dartx.length]); i++) {
      if (i >= dart.notNull(b[dartx.length])) return 1;
      let aChar = a[dartx.codeUnitAt](i);
      let bChar = b[dartx.codeUnitAt](i);
      if (aChar == bChar) continue;
      let aUpperCase = aChar;
      let bUpperCase = bChar;
      if (dart.notNull(comparators._lowerCaseA) <= dart.notNull(aChar) && dart.notNull(aChar) <= dart.notNull(comparators._lowerCaseZ)) {
        aUpperCase = dart.notNull(aUpperCase) - dart.notNull(comparators._asciiCaseBit);
      }
      if (dart.notNull(comparators._lowerCaseA) <= dart.notNull(bChar) && dart.notNull(bChar) <= dart.notNull(comparators._lowerCaseZ)) {
        bUpperCase = dart.notNull(bUpperCase) - dart.notNull(comparators._asciiCaseBit);
      }
      if (aUpperCase != bUpperCase) return (dart.notNull(aUpperCase) - dart.notNull(bUpperCase))[dartx.sign];
      if (defaultResult == 0) defaultResult = dart.notNull(aChar) - dart.notNull(bChar);
    }
    if (dart.notNull(b[dartx.length]) > dart.notNull(a[dartx.length])) return -1;
    return defaultResult[dartx.sign];
  };
  dart.fn(comparators.compareAsciiUpperCase, core.int, [core.String, core.String]);
  collection$.compareAsciiUpperCase = comparators.compareAsciiUpperCase;
  comparators.compareNatural = function(a, b) {
    for (let i = 0; i < dart.notNull(a[dartx.length]); i++) {
      if (i >= dart.notNull(b[dartx.length])) return 1;
      let aChar = a[dartx.codeUnitAt](i);
      let bChar = b[dartx.codeUnitAt](i);
      if (aChar != bChar) {
        return comparators._compareNaturally(a, b, i, aChar, bChar);
      }
    }
    if (dart.notNull(b[dartx.length]) > dart.notNull(a[dartx.length])) return -1;
    return 0;
  };
  dart.fn(comparators.compareNatural, core.int, [core.String, core.String]);
  collection$.compareNatural = comparators.compareNatural;
  comparators.compareAsciiLowerCaseNatural = function(a, b) {
    let defaultResult = 0;
    for (let i = 0; i < dart.notNull(a[dartx.length]); i++) {
      if (i >= dart.notNull(b[dartx.length])) return 1;
      let aChar = a[dartx.codeUnitAt](i);
      let bChar = b[dartx.codeUnitAt](i);
      if (aChar == bChar) continue;
      let aLowerCase = aChar;
      let bLowerCase = bChar;
      if (dart.notNull(comparators._upperCaseA) <= dart.notNull(aChar) && dart.notNull(aChar) <= dart.notNull(comparators._upperCaseZ)) {
        aLowerCase = dart.notNull(aLowerCase) + dart.notNull(comparators._asciiCaseBit);
      }
      if (dart.notNull(comparators._upperCaseA) <= dart.notNull(bChar) && dart.notNull(bChar) <= dart.notNull(comparators._upperCaseZ)) {
        bLowerCase = dart.notNull(bLowerCase) + dart.notNull(comparators._asciiCaseBit);
      }
      if (aLowerCase != bLowerCase) {
        return comparators._compareNaturally(a, b, i, aLowerCase, bLowerCase);
      }
      if (defaultResult == 0) defaultResult = dart.notNull(aChar) - dart.notNull(bChar);
    }
    if (dart.notNull(b[dartx.length]) > dart.notNull(a[dartx.length])) return -1;
    return defaultResult[dartx.sign];
  };
  dart.fn(comparators.compareAsciiLowerCaseNatural, core.int, [core.String, core.String]);
  collection$.compareAsciiLowerCaseNatural = comparators.compareAsciiLowerCaseNatural;
  comparators.compareAsciiLowerCase = function(a, b) {
    let defaultResult = 0;
    for (let i = 0; i < dart.notNull(a[dartx.length]); i++) {
      if (i >= dart.notNull(b[dartx.length])) return 1;
      let aChar = a[dartx.codeUnitAt](i);
      let bChar = b[dartx.codeUnitAt](i);
      if (aChar == bChar) continue;
      let aLowerCase = aChar;
      let bLowerCase = bChar;
      if (dart.notNull(comparators._upperCaseA) <= dart.notNull(bChar) && dart.notNull(bChar) <= dart.notNull(comparators._upperCaseZ)) {
        bLowerCase = dart.notNull(bLowerCase) + dart.notNull(comparators._asciiCaseBit);
      }
      if (dart.notNull(comparators._upperCaseA) <= dart.notNull(aChar) && dart.notNull(aChar) <= dart.notNull(comparators._upperCaseZ)) {
        aLowerCase = dart.notNull(aLowerCase) + dart.notNull(comparators._asciiCaseBit);
      }
      if (aLowerCase != bLowerCase) return (dart.notNull(aLowerCase) - dart.notNull(bLowerCase))[dartx.sign];
      if (defaultResult == 0) defaultResult = dart.notNull(aChar) - dart.notNull(bChar);
    }
    if (dart.notNull(b[dartx.length]) > dart.notNull(a[dartx.length])) return -1;
    return defaultResult[dartx.sign];
  };
  dart.fn(comparators.compareAsciiLowerCase, core.int, [core.String, core.String]);
  collection$.compareAsciiLowerCase = comparators.compareAsciiLowerCase;
  comparators.compareAsciiUpperCaseNatural = function(a, b) {
    let defaultResult = 0;
    for (let i = 0; i < dart.notNull(a[dartx.length]); i++) {
      if (i >= dart.notNull(b[dartx.length])) return 1;
      let aChar = a[dartx.codeUnitAt](i);
      let bChar = b[dartx.codeUnitAt](i);
      if (aChar == bChar) continue;
      let aUpperCase = aChar;
      let bUpperCase = bChar;
      if (dart.notNull(comparators._lowerCaseA) <= dart.notNull(aChar) && dart.notNull(aChar) <= dart.notNull(comparators._lowerCaseZ)) {
        aUpperCase = dart.notNull(aUpperCase) - dart.notNull(comparators._asciiCaseBit);
      }
      if (dart.notNull(comparators._lowerCaseA) <= dart.notNull(bChar) && dart.notNull(bChar) <= dart.notNull(comparators._lowerCaseZ)) {
        bUpperCase = dart.notNull(bUpperCase) - dart.notNull(comparators._asciiCaseBit);
      }
      if (aUpperCase != bUpperCase) {
        return comparators._compareNaturally(a, b, i, aUpperCase, bUpperCase);
      }
      if (defaultResult == 0) defaultResult = dart.notNull(aChar) - dart.notNull(bChar);
    }
    if (dart.notNull(b[dartx.length]) > dart.notNull(a[dartx.length])) return -1;
    return defaultResult[dartx.sign];
  };
  dart.fn(comparators.compareAsciiUpperCaseNatural, core.int, [core.String, core.String]);
  collection$.compareAsciiUpperCaseNatural = comparators.compareAsciiUpperCaseNatural;
  comparators.equalsIgnoreAsciiCase = function(a, b) {
    if (a[dartx.length] != b[dartx.length]) return false;
    for (let i = 0; i < dart.notNull(a[dartx.length]); i++) {
      let aChar = a[dartx.codeUnitAt](i);
      let bChar = b[dartx.codeUnitAt](i);
      if (aChar == bChar) continue;
      if ((dart.notNull(aChar) ^ dart.notNull(bChar)) != comparators._asciiCaseBit) return false;
      let aCharUpperCase = dart.notNull(aChar) | dart.notNull(comparators._asciiCaseBit);
      if (dart.notNull(comparators._upperCaseA) <= aCharUpperCase && aCharUpperCase <= dart.notNull(comparators._upperCaseZ)) {
        continue;
      }
      return false;
    }
    return true;
  };
  dart.fn(comparators.equalsIgnoreAsciiCase, core.bool, [core.String, core.String]);
  collection$.equalsIgnoreAsciiCase = comparators.equalsIgnoreAsciiCase;
  comparators.hashIgnoreAsciiCase = function(string) {
    let hash = 0;
    for (let i = 0; i < dart.notNull(string[dartx.length]); i++) {
      let char = string[dartx.codeUnitAt](i);
      if (dart.notNull(comparators._lowerCaseA) <= dart.notNull(char) && dart.notNull(char) <= dart.notNull(comparators._lowerCaseZ)) {
        char = dart.notNull(char) - dart.notNull(comparators._asciiCaseBit);
      }
      hash = 536870911 & hash + dart.notNull(char);
      hash = 536870911 & hash + ((524287 & hash) << 10);
      hash = hash >> 6;
    }
    hash = 536870911 & hash + ((67108863 & hash) << 3);
    hash = hash >> 11;
    return 536870911 & hash + ((16383 & hash) << 15);
  };
  dart.fn(comparators.hashIgnoreAsciiCase, core.int, [core.String]);
  collection$.hashIgnoreAsciiCase = comparators.hashIgnoreAsciiCase;
  equality.DefaultEquality$ = dart.generic(E => {
    class DefaultEquality extends core.Object {
      DefaultEquality() {
      }
      equals(e1, e2) {
        dart.as(e1, E);
        dart.as(e2, E);
        return dart.equals(e1, e2);
      }
      hash(e) {
        dart.as(e, E);
        return dart.hashCode(e);
      }
      isValidKey(o) {
        return true;
      }
    }
    DefaultEquality[dart.implements] = () => [equality.Equality$(E)];
    dart.setSignature(DefaultEquality, {
      constructors: () => ({DefaultEquality: [equality.DefaultEquality$(E), []]}),
      methods: () => ({
        equals: [core.bool, [E, E]],
        hash: [core.int, [E]],
        isValidKey: [core.bool, [core.Object]]
      })
    });
    return DefaultEquality;
  });
  equality.DefaultEquality = equality.DefaultEquality$();
  const _keyEquality = Symbol('_keyEquality');
  const _valueEquality = Symbol('_valueEquality');
  equality.MapEquality$ = dart.generic((K, V) => {
    class MapEquality extends core.Object {
      MapEquality(opts) {
        let keys = opts && 'keys' in opts ? opts.keys : dart.const(new (equality.DefaultEquality$(K))());
        let values = opts && 'values' in opts ? opts.values : dart.const(new (equality.DefaultEquality$(V))());
        this[_keyEquality] = keys;
        this[_valueEquality] = values;
      }
      equals(e1, e2) {
        dart.as(e1, core.Map$(K, V));
        dart.as(e2, core.Map$(K, V));
        if (core.identical(e1, e2)) return true;
        if (e1 == null || e2 == null) return false;
        let length = e1[dartx.length];
        if (length != e2[dartx.length]) return false;
        let equalElementCounts = collection.HashMap$(equality._MapEntry, core.int).new();
        for (let key of e1[dartx.keys]) {
          let entry = new equality._MapEntry(this, key, e1[dartx.get](key));
          let count = equalElementCounts[dartx.get](entry);
          if (count == null) count = 0;
          equalElementCounts[dartx.set](entry, dart.notNull(count) + 1);
        }
        for (let key of e2[dartx.keys]) {
          let entry = new equality._MapEntry(this, key, e2[dartx.get](key));
          let count = equalElementCounts[dartx.get](entry);
          if (count == null || count == 0) return false;
          equalElementCounts[dartx.set](entry, dart.notNull(count) - 1);
        }
        return true;
      }
      hash(map) {
        dart.as(map, core.Map$(K, V));
        let hash = 0;
        for (let key of map[dartx.keys]) {
          let keyHash = this[_keyEquality].hash(key);
          let valueHash = this[_valueEquality].hash(map[dartx.get](key));
          hash = dart.notNull(hash) + 3 * dart.notNull(keyHash) + 7 * dart.notNull(valueHash) & dart.notNull(equality._HASH_MASK);
        }
        hash = dart.notNull(hash) + (dart.notNull(hash) << 3) & dart.notNull(equality._HASH_MASK);
        hash = dart.notNull(hash) ^ dart.notNull(hash) >> 11;
        hash = dart.notNull(hash) + (dart.notNull(hash) << 15) & dart.notNull(equality._HASH_MASK);
        return hash;
      }
      isValidKey(o) {
        return dart.is(o, core.Map$(K, V));
      }
    }
    MapEquality[dart.implements] = () => [equality.Equality$(core.Map$(K, V))];
    dart.setSignature(MapEquality, {
      constructors: () => ({MapEquality: [equality.MapEquality$(K, V), [], {keys: equality.Equality$(K), values: equality.Equality$(V)}]}),
      methods: () => ({
        equals: [core.bool, [core.Map$(K, V), core.Map$(K, V)]],
        hash: [core.int, [core.Map$(K, V)]],
        isValidKey: [core.bool, [core.Object]]
      })
    });
    return MapEquality;
  });
  equality.MapEquality = equality.MapEquality$();
  collection$.MapEquality$ = equality.MapEquality$;
  collection$.MapEquality = equality.MapEquality;
  const _base$ = Symbol('_base');
  const _unordered = Symbol('_unordered');
  equality.DeepCollectionEquality = class DeepCollectionEquality extends core.Object {
    DeepCollectionEquality(base) {
      if (base === void 0) base = dart.const(new equality.DefaultEquality());
      this[_base$] = base;
      this[_unordered] = false;
    }
    unordered(base) {
      if (base === void 0) base = dart.const(new equality.DefaultEquality());
      this[_base$] = base;
      this[_unordered] = true;
    }
    equals(e1, e2) {
      if (dart.is(e1, core.Set)) {
        if (!dart.is(e2, core.Set)) return false;
        return new equality.SetEquality(this).equals(e1, dart.as(e2, core.Set));
      }
      if (dart.is(e1, core.Map)) {
        if (!dart.is(e2, core.Map)) return false;
        return new equality.MapEquality({keys: this, values: this}).equals(e1, dart.as(e2, core.Map));
      }
      if (!dart.notNull(this[_unordered])) {
        if (dart.is(e1, core.List)) {
          if (!dart.is(e2, core.List)) return false;
          return new equality.ListEquality(this).equals(e1, dart.as(e2, core.List));
        }
        if (dart.is(e1, core.Iterable)) {
          if (!dart.is(e2, core.Iterable)) return false;
          return new equality.IterableEquality(this).equals(e1, dart.as(e2, core.Iterable));
        }
      } else if (dart.is(e1, core.Iterable)) {
        if (!dart.is(e2, core.Iterable)) return false;
        if (dart.is(e1, core.List) != dart.is(e2, core.List)) return false;
        return new equality.UnorderedIterableEquality(this).equals(e1, dart.as(e2, core.Iterable));
      }
      return this[_base$].equals(e1, e2);
    }
    hash(o) {
      if (dart.is(o, core.Set)) return new equality.SetEquality(this).hash(o);
      if (dart.is(o, core.Map)) return new equality.MapEquality({keys: this, values: this}).hash(o);
      if (!dart.notNull(this[_unordered])) {
        if (dart.is(o, core.List)) return new equality.ListEquality(this).hash(o);
        if (dart.is(o, core.Iterable)) return new equality.IterableEquality(this).hash(o);
      } else if (dart.is(o, core.Iterable)) {
        return new equality.UnorderedIterableEquality(this).hash(o);
      }
      return this[_base$].hash(o);
    }
    isValidKey(o) {
      return dart.is(o, core.Iterable) || dart.is(o, core.Map) || dart.notNull(this[_base$].isValidKey(o));
    }
  };
  dart.defineNamedConstructor(equality.DeepCollectionEquality, 'unordered');
  equality.DeepCollectionEquality[dart.implements] = () => [equality.Equality];
  dart.setSignature(equality.DeepCollectionEquality, {
    constructors: () => ({
      DeepCollectionEquality: [equality.DeepCollectionEquality, [], [equality.Equality]],
      unordered: [equality.DeepCollectionEquality, [], [equality.Equality]]
    }),
    methods: () => ({
      equals: [core.bool, [dart.dynamic, dart.dynamic]],
      hash: [core.int, [core.Object]],
      isValidKey: [core.bool, [core.Object]]
    })
  });
  collection$.DeepCollectionEquality = equality.DeepCollectionEquality;
  collection$.DefaultEquality$ = equality.DefaultEquality$;
  collection$.DefaultEquality = equality.DefaultEquality;
  const _equalities = Symbol('_equalities');
  equality.MultiEquality$ = dart.generic(E => {
    class MultiEquality extends core.Object {
      MultiEquality(equalities) {
        this[_equalities] = equalities;
      }
      equals(e1, e2) {
        dart.as(e1, E);
        dart.as(e2, E);
        for (let eq of this[_equalities]) {
          if (dart.notNull(eq.isValidKey(e1))) return dart.notNull(eq.isValidKey(e2)) && dart.notNull(eq.equals(e1, e2));
        }
        return false;
      }
      hash(e) {
        dart.as(e, E);
        for (let eq of this[_equalities]) {
          if (dart.notNull(eq.isValidKey(e))) return eq.hash(e);
        }
        return -1;
      }
      isValidKey(o) {
        for (let eq of this[_equalities]) {
          if (dart.notNull(eq.isValidKey(o))) return true;
        }
        return false;
      }
    }
    MultiEquality[dart.implements] = () => [equality.Equality$(E)];
    dart.setSignature(MultiEquality, {
      constructors: () => ({MultiEquality: [equality.MultiEquality$(E), [core.Iterable$(equality.Equality$(E))]]}),
      methods: () => ({
        equals: [core.bool, [E, E]],
        hash: [core.int, [E]],
        isValidKey: [core.bool, [core.Object]]
      })
    });
    return MultiEquality;
  });
  equality.MultiEquality = equality.MultiEquality$();
  collection$.MultiEquality$ = equality.MultiEquality$;
  collection$.MultiEquality = equality.MultiEquality;
  equality.IdentityEquality$ = dart.generic(E => {
    class IdentityEquality extends core.Object {
      IdentityEquality() {
      }
      equals(e1, e2) {
        dart.as(e1, E);
        dart.as(e2, E);
        return core.identical(e1, e2);
      }
      hash(e) {
        dart.as(e, E);
        return core.identityHashCode(e);
      }
      isValidKey(o) {
        return true;
      }
    }
    IdentityEquality[dart.implements] = () => [equality.Equality$(E)];
    dart.setSignature(IdentityEquality, {
      constructors: () => ({IdentityEquality: [equality.IdentityEquality$(E), []]}),
      methods: () => ({
        equals: [core.bool, [E, E]],
        hash: [core.int, [E]],
        isValidKey: [core.bool, [core.Object]]
      })
    });
    return IdentityEquality;
  });
  equality.IdentityEquality = equality.IdentityEquality$();
  collection$.IdentityEquality$ = equality.IdentityEquality$;
  collection$.IdentityEquality = equality.IdentityEquality;
  const _elementEquality = Symbol('_elementEquality');
  equality._UnorderedEquality$ = dart.generic((E, T) => {
    class _UnorderedEquality extends core.Object {
      _UnorderedEquality(elementEquality) {
        this[_elementEquality] = elementEquality;
      }
      equals(e1, e2) {
        dart.as(e1, T);
        dart.as(e2, T);
        if (core.identical(e1, e2)) return true;
        if (e1 == null || e2 == null) return false;
        let counts = collection.HashMap$(E, core.int).new({equals: dart.bind(this[_elementEquality], 'equals'), hashCode: dart.bind(this[_elementEquality], 'hash'), isValidKey: dart.bind(this[_elementEquality], 'isValidKey')});
        let length = 0;
        for (let e of e1) {
          let count = counts.get(e);
          if (count == null) count = 0;
          counts.set(e, dart.notNull(count) + 1);
          length++;
        }
        for (let e of e2) {
          let count = counts.get(e);
          if (count == null || count == 0) return false;
          counts.set(e, dart.notNull(count) - 1);
          length--;
        }
        return length == 0;
      }
      hash(e) {
        dart.as(e, T);
        let hash = 0;
        for (let element of e) {
          let c = this[_elementEquality].hash(element);
          hash = hash + dart.notNull(c) & dart.notNull(equality._HASH_MASK);
        }
        hash = hash + (hash << 3) & dart.notNull(equality._HASH_MASK);
        hash = hash ^ hash >> 11;
        hash = hash + (hash << 15) & dart.notNull(equality._HASH_MASK);
        return hash;
      }
    }
    _UnorderedEquality[dart.implements] = () => [equality.Equality$(T)];
    dart.setSignature(_UnorderedEquality, {
      constructors: () => ({_UnorderedEquality: [equality._UnorderedEquality$(E, T), [equality.Equality$(E)]]}),
      methods: () => ({
        equals: [core.bool, [T, T]],
        hash: [core.int, [T]]
      })
    });
    return _UnorderedEquality;
  });
  equality._UnorderedEquality = equality._UnorderedEquality$();
  equality.UnorderedIterableEquality$ = dart.generic(E => {
    class UnorderedIterableEquality extends equality._UnorderedEquality$(E, core.Iterable$(E)) {
      UnorderedIterableEquality(elementEquality) {
        if (elementEquality === void 0) elementEquality = dart.const(new (equality.DefaultEquality$(E))());
        super._UnorderedEquality(elementEquality);
      }
      isValidKey(o) {
        return dart.is(o, core.Iterable$(E));
      }
    }
    dart.setSignature(UnorderedIterableEquality, {
      constructors: () => ({UnorderedIterableEquality: [equality.UnorderedIterableEquality$(E), [], [equality.Equality$(E)]]}),
      methods: () => ({isValidKey: [core.bool, [core.Object]]})
    });
    return UnorderedIterableEquality;
  });
  equality.UnorderedIterableEquality = equality.UnorderedIterableEquality$();
  collection$.UnorderedIterableEquality$ = equality.UnorderedIterableEquality$;
  collection$.UnorderedIterableEquality = equality.UnorderedIterableEquality;
  equality.ListEquality$ = dart.generic(E => {
    class ListEquality extends core.Object {
      ListEquality(elementEquality) {
        if (elementEquality === void 0) elementEquality = dart.const(new (equality.DefaultEquality$(E))());
        this[_elementEquality] = elementEquality;
      }
      equals(e1, e2) {
        dart.as(e1, core.List$(E));
        dart.as(e2, core.List$(E));
        if (core.identical(e1, e2)) return true;
        if (e1 == null || e2 == null) return false;
        let length = e1[dartx.length];
        if (length != e2[dartx.length]) return false;
        for (let i = 0; i < dart.notNull(length); i++) {
          if (!dart.notNull(this[_elementEquality].equals(e1[dartx.get](i), e2[dartx.get](i)))) return false;
        }
        return true;
      }
      hash(e) {
        dart.as(e, core.List$(E));
        let hash = 0;
        for (let i = 0; i < dart.notNull(e[dartx.length]); i++) {
          let c = this[_elementEquality].hash(e[dartx.get](i));
          hash = hash + dart.notNull(c) & dart.notNull(equality._HASH_MASK);
          hash = hash + (hash << 10) & dart.notNull(equality._HASH_MASK);
          hash = hash ^ hash >> 6;
        }
        hash = hash + (hash << 3) & dart.notNull(equality._HASH_MASK);
        hash = hash ^ hash >> 11;
        hash = hash + (hash << 15) & dart.notNull(equality._HASH_MASK);
        return hash;
      }
      isValidKey(o) {
        return dart.is(o, core.List$(E));
      }
    }
    ListEquality[dart.implements] = () => [equality.Equality$(core.List$(E))];
    dart.setSignature(ListEquality, {
      constructors: () => ({ListEquality: [equality.ListEquality$(E), [], [equality.Equality$(E)]]}),
      methods: () => ({
        equals: [core.bool, [core.List$(E), core.List$(E)]],
        hash: [core.int, [core.List$(E)]],
        isValidKey: [core.bool, [core.Object]]
      })
    });
    return ListEquality;
  });
  equality.ListEquality = equality.ListEquality$();
  collection$.ListEquality$ = equality.ListEquality$;
  collection$.ListEquality = equality.ListEquality;
  equality.SetEquality$ = dart.generic(E => {
    class SetEquality extends equality._UnorderedEquality$(E, core.Set$(E)) {
      SetEquality(elementEquality) {
        if (elementEquality === void 0) elementEquality = dart.const(new (equality.DefaultEquality$(E))());
        super._UnorderedEquality(elementEquality);
      }
      isValidKey(o) {
        return dart.is(o, core.Set$(E));
      }
    }
    dart.setSignature(SetEquality, {
      constructors: () => ({SetEquality: [equality.SetEquality$(E), [], [equality.Equality$(E)]]}),
      methods: () => ({isValidKey: [core.bool, [core.Object]]})
    });
    return SetEquality;
  });
  equality.SetEquality = equality.SetEquality$();
  collection$.SetEquality$ = equality.SetEquality$;
  collection$.SetEquality = equality.SetEquality;
  equality.IterableEquality$ = dart.generic(E => {
    class IterableEquality extends core.Object {
      IterableEquality(elementEquality) {
        if (elementEquality === void 0) elementEquality = dart.const(new (equality.DefaultEquality$(E))());
        this[_elementEquality] = elementEquality;
      }
      equals(elements1, elements2) {
        dart.as(elements1, core.Iterable$(E));
        dart.as(elements2, core.Iterable$(E));
        if (core.identical(elements1, elements2)) return true;
        if (elements1 == null || elements2 == null) return false;
        let it1 = elements1[dartx.iterator];
        let it2 = elements2[dartx.iterator];
        while (true) {
          let hasNext = it1.moveNext();
          if (hasNext != it2.moveNext()) return false;
          if (!dart.notNull(hasNext)) return true;
          if (!dart.notNull(this[_elementEquality].equals(it1.current, it2.current))) return false;
        }
      }
      hash(elements) {
        dart.as(elements, core.Iterable$(E));
        let hash = 0;
        for (let element of elements) {
          let c = this[_elementEquality].hash(element);
          hash = hash + dart.notNull(c) & dart.notNull(equality._HASH_MASK);
          hash = hash + (hash << 10) & dart.notNull(equality._HASH_MASK);
          hash = hash ^ hash >> 6;
        }
        hash = hash + (hash << 3) & dart.notNull(equality._HASH_MASK);
        hash = hash ^ hash >> 11;
        hash = hash + (hash << 15) & dart.notNull(equality._HASH_MASK);
        return hash;
      }
      isValidKey(o) {
        return dart.is(o, core.Iterable$(E));
      }
    }
    IterableEquality[dart.implements] = () => [equality.Equality$(core.Iterable$(E))];
    dart.setSignature(IterableEquality, {
      constructors: () => ({IterableEquality: [equality.IterableEquality$(E), [], [equality.Equality$(E)]]}),
      methods: () => ({
        equals: [core.bool, [core.Iterable$(E), core.Iterable$(E)]],
        hash: [core.int, [core.Iterable$(E)]],
        isValidKey: [core.bool, [core.Object]]
      })
    });
    return IterableEquality;
  });
  equality.IterableEquality = equality.IterableEquality$();
  collection$.IterableEquality$ = equality.IterableEquality$;
  collection$.IterableEquality = equality.IterableEquality;
  equality.Equality$ = dart.generic(E => {
    class Equality extends core.Object {
      static new() {
        return new (equality.DefaultEquality$(E))();
      }
    }
    dart.setSignature(Equality, {
      constructors: () => ({new: [equality.Equality$(E), []]})
    });
    return Equality;
  });
  equality.Equality = equality.Equality$();
  collection$.Equality$ = equality.Equality$;
  collection$.Equality = equality.Equality;
  const _iterables = Symbol('_iterables');
  iterable_zip.IterableZip$ = dart.generic(T => {
    class IterableZip extends collection.IterableBase$(core.List$(T)) {
      IterableZip(iterables) {
        this[_iterables] = iterables;
        super.IterableBase();
      }
      get iterator() {
        let iterators = this[_iterables][dartx.map](dart.fn(x => {
          dart.as(x, core.Iterable$(T));
          return x[dartx.iterator];
        }, core.Iterator$(T), [core.Iterable$(T)]))[dartx.toList]({growable: false});
        return new (iterable_zip._IteratorZip$(T))(iterators);
      }
    }
    dart.setSignature(IterableZip, {
      constructors: () => ({IterableZip: [iterable_zip.IterableZip$(T), [core.Iterable$(core.Iterable$(T))]]})
    });
    dart.defineExtensionMembers(IterableZip, ['iterator']);
    return IterableZip;
  });
  iterable_zip.IterableZip = iterable_zip.IterableZip$();
  collection$.IterableZip$ = iterable_zip.IterableZip$;
  collection$.IterableZip = iterable_zip.IterableZip;
  const _queue = Symbol('_queue');
  const _length = Symbol('_length');
  const _add = Symbol('_add');
  const _locate = Symbol('_locate');
  const _removeLast = Symbol('_removeLast');
  const _bubbleUp = Symbol('_bubbleUp');
  const _bubbleDown = Symbol('_bubbleDown');
  const _grow = Symbol('_grow');
  priority_queue.HeapPriorityQueue$ = dart.generic(E => {
    class HeapPriorityQueue extends core.Object {
      HeapPriorityQueue(comparison) {
        if (comparison === void 0) comparison = null;
        this[_queue] = core.List$(E).new(priority_queue.HeapPriorityQueue._INITIAL_CAPACITY);
        this.comparison = (() => {
          let l = comparison;
          return l != null ? l : utils.defaultCompare();
        })();
        this[_length] = 0;
      }
      add(element) {
        dart.as(element, E);
        this[_add](element);
      }
      addAll(elements) {
        dart.as(elements, core.Iterable$(E));
        for (let element of elements) {
          this[_add](element);
        }
      }
      clear() {
        this[_queue] = dart.const(dart.list([], E));
        this[_length] = 0;
      }
      contains(object) {
        dart.as(object, E);
        return dart.notNull(this[_locate](object)) >= 0;
      }
      get first() {
        if (this[_length] == 0) dart.throw(new core.StateError("No such element"));
        return this[_queue][dartx.get](0);
      }
      get isEmpty() {
        return this[_length] == 0;
      }
      get isNotEmpty() {
        return this[_length] != 0;
      }
      get length() {
        return this[_length];
      }
      remove(element) {
        dart.as(element, E);
        let index = this[_locate](element);
        if (dart.notNull(index) < 0) return false;
        let last = this[_removeLast]();
        if (dart.notNull(index) < dart.notNull(this[_length])) {
          let comp = this.comparison(last, element);
          if (dart.notNull(comp) <= 0) {
            this[_bubbleUp](last, index);
          } else {
            this[_bubbleDown](last, index);
          }
        }
        return true;
      }
      removeAll() {
        let result = this[_queue];
        let length = this[_length];
        this[_queue] = dart.const(dart.list([], E));
        this[_length] = 0;
        return result[dartx.take](length);
      }
      removeFirst() {
        if (this[_length] == 0) dart.throw(new core.StateError("No such element"));
        let result = this[_queue][dartx.get](0);
        let last = this[_removeLast]();
        if (dart.notNull(this[_length]) > 0) {
          this[_bubbleDown](last, 0);
        }
        return result;
      }
      toList() {
        let list = core.List$(E).new();
        list[dartx.length] = this[_length];
        list[dartx.setRange](0, this[_length], this[_queue]);
        list[dartx.sort](this.comparison);
        return list;
      }
      toSet() {
        let set = new (collection.SplayTreeSet$(E))(this.comparison);
        for (let i = 0; i < dart.notNull(this[_length]); i++) {
          set.add(this[_queue][dartx.get](i));
        }
        return set;
      }
      toString() {
        return dart.toString(this[_queue][dartx.take](this[_length]));
      }
      [_add](element) {
        dart.as(element, E);
        if (this[_length] == this[_queue][dartx.length]) this[_grow]();
        this[_bubbleUp](element, (() => {
          let x = this[_length];
          this[_length] = dart.notNull(x) + 1;
          return x;
        })());
      }
      [_locate](object) {
        dart.as(object, E);
        if (this[_length] == 0) return -1;
        let position = 1;
        do {
          let index = position - 1;
          let element = this[_queue][dartx.get](index);
          let comp = this.comparison(element, object);
          if (comp == 0) return index;
          if (dart.notNull(comp) < 0) {
            let leftChildPosition = position * 2;
            if (leftChildPosition <= dart.notNull(this[_length])) {
              position = leftChildPosition;
              continue;
            }
          }
          do {
            while (dart.notNull(position[dartx.isOdd])) {
              position = position >> 1;
            }
            position = position + 1;
          } while (position > dart.notNull(this[_length]));
        } while (position != 1);
        return -1;
      }
      [_removeLast]() {
        let newLength = dart.notNull(this[_length]) - 1;
        let last = this[_queue][dartx.get](newLength);
        this[_queue][dartx.set](newLength, null);
        this[_length] = newLength;
        return last;
      }
      [_bubbleUp](element, index) {
        dart.as(element, E);
        while (dart.notNull(index) > 0) {
          let parentIndex = ((dart.notNull(index) - 1) / 2)[dartx.truncate]();
          let parent = this[_queue][dartx.get](parentIndex);
          if (dart.notNull(this.comparison(element, parent)) > 0) break;
          this[_queue][dartx.set](index, parent);
          index = parentIndex;
        }
        this[_queue][dartx.set](index, element);
      }
      [_bubbleDown](element, index) {
        dart.as(element, E);
        let rightChildIndex = dart.notNull(index) * 2 + 2;
        while (rightChildIndex < dart.notNull(this[_length])) {
          let leftChildIndex = rightChildIndex - 1;
          let leftChild = this[_queue][dartx.get](leftChildIndex);
          let rightChild = this[_queue][dartx.get](rightChildIndex);
          let comp = this.comparison(leftChild, rightChild);
          let minChildIndex = null;
          let minChild = null;
          if (dart.notNull(comp) < 0) {
            minChild = leftChild;
            minChildIndex = leftChildIndex;
          } else {
            minChild = rightChild;
            minChildIndex = rightChildIndex;
          }
          comp = this.comparison(element, minChild);
          if (dart.notNull(comp) <= 0) {
            this[_queue][dartx.set](index, element);
            return;
          }
          this[_queue][dartx.set](index, minChild);
          index = minChildIndex;
          rightChildIndex = dart.notNull(index) * 2 + 2;
        }
        let leftChildIndex = rightChildIndex - 1;
        if (leftChildIndex < dart.notNull(this[_length])) {
          let child = this[_queue][dartx.get](leftChildIndex);
          let comp = this.comparison(element, child);
          if (dart.notNull(comp) > 0) {
            this[_queue][dartx.set](index, child);
            index = leftChildIndex;
          }
        }
        this[_queue][dartx.set](index, element);
      }
      [_grow]() {
        let newCapacity = dart.notNull(this[_queue][dartx.length]) * 2 + 1;
        if (dart.notNull(newCapacity) < dart.notNull(priority_queue.HeapPriorityQueue._INITIAL_CAPACITY)) newCapacity = priority_queue.HeapPriorityQueue._INITIAL_CAPACITY;
        let newQueue = core.List$(E).new(newCapacity);
        newQueue[dartx.setRange](0, this[_length], this[_queue]);
        this[_queue] = newQueue;
      }
    }
    HeapPriorityQueue[dart.implements] = () => [priority_queue.PriorityQueue$(E)];
    dart.setSignature(HeapPriorityQueue, {
      constructors: () => ({HeapPriorityQueue: [priority_queue.HeapPriorityQueue$(E), [], [dart.functionType(core.int, [E, E])]]}),
      methods: () => ({
        add: [dart.void, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        clear: [dart.void, []],
        contains: [core.bool, [E]],
        remove: [core.bool, [E]],
        removeAll: [core.Iterable$(E), []],
        removeFirst: [E, []],
        toList: [core.List$(E), []],
        toSet: [core.Set$(E), []],
        [_add]: [dart.void, [E]],
        [_locate]: [core.int, [E]],
        [_removeLast]: [E, []],
        [_bubbleUp]: [dart.void, [E, core.int]],
        [_bubbleDown]: [dart.void, [E, core.int]],
        [_grow]: [dart.void, []]
      })
    });
    return HeapPriorityQueue;
  });
  priority_queue.HeapPriorityQueue = priority_queue.HeapPriorityQueue$();
  priority_queue.HeapPriorityQueue._INITIAL_CAPACITY = 7;
  collection$.HeapPriorityQueue$ = priority_queue.HeapPriorityQueue$;
  collection$.HeapPriorityQueue = priority_queue.HeapPriorityQueue;
  priority_queue.PriorityQueue$ = dart.generic(E => {
    class PriorityQueue extends core.Object {
      static new(comparison) {
        return new (priority_queue.HeapPriorityQueue$(E))(comparison);
      }
    }
    dart.setSignature(PriorityQueue, {
      constructors: () => ({new: [priority_queue.PriorityQueue$(E), [], [dart.functionType(core.int, [E, E])]]})
    });
    return PriorityQueue;
  });
  priority_queue.PriorityQueue = priority_queue.PriorityQueue$();
  collection$.PriorityQueue$ = priority_queue.PriorityQueue$;
  collection$.PriorityQueue = priority_queue.PriorityQueue;
  const _head = Symbol('_head');
  const _tail = Symbol('_tail');
  const _table = Symbol('_table');
  const _add$ = Symbol('_add');
  const _preGrow = Symbol('_preGrow');
  const _grow$ = Symbol('_grow');
  const _writeToList = Symbol('_writeToList');
  queue_list.QueueList$ = dart.generic(E => {
    class QueueList extends dart.mixin(core.Object, collection.ListMixin$(E)) {
      QueueList(initialCapacity) {
        if (initialCapacity === void 0) initialCapacity = null;
        this[_head] = 0;
        this[_tail] = 0;
        this[_table] = null;
        if (initialCapacity == null || dart.notNull(initialCapacity) < dart.notNull(queue_list.QueueList._INITIAL_CAPACITY)) {
          initialCapacity = queue_list.QueueList._INITIAL_CAPACITY;
        } else if (!dart.notNull(queue_list.QueueList._isPowerOf2(initialCapacity))) {
          initialCapacity = queue_list.QueueList._nextPowerOf2(initialCapacity);
        }
        dart.assert(queue_list.QueueList._isPowerOf2(initialCapacity));
        this[_table] = core.List$(E).new(initialCapacity);
      }
      static from(source) {
        if (dart.is(source, core.List)) {
          let length = source[dartx.length];
          let queue = new (queue_list.QueueList$(E))(dart.notNull(length) + 1);
          dart.assert(dart.notNull(queue[_table][dartx.length]) > dart.notNull(length));
          let sourceList = source;
          queue[_table][dartx.setRange](0, length, sourceList, 0);
          queue[_tail] = length;
          return queue;
        } else {
          let _ = new (queue_list.QueueList$(E))();
          _.addAll(source);
          return _;
        }
      }
      add(element) {
        dart.as(element, E);
        this[_add$](element);
      }
      addAll(elements) {
        dart.as(elements, core.Iterable$(E));
        if (dart.is(elements, core.List)) {
          let list = elements;
          let addCount = list[dartx.length];
          let length = this.length;
          if (dart.notNull(length) + dart.notNull(addCount) >= dart.notNull(this[_table][dartx.length])) {
            this[_preGrow](dart.notNull(length) + dart.notNull(addCount));
            this[_table][dartx.setRange](length, dart.notNull(length) + dart.notNull(addCount), list, 0);
            this[_tail] = dart.notNull(this[_tail]) + dart.notNull(addCount);
          } else {
            let endSpace = dart.notNull(this[_table][dartx.length]) - dart.notNull(this[_tail]);
            if (dart.notNull(addCount) < endSpace) {
              this[_table][dartx.setRange](this[_tail], dart.notNull(this[_tail]) + dart.notNull(addCount), list, 0);
              this[_tail] = dart.notNull(this[_tail]) + dart.notNull(addCount);
            } else {
              let preSpace = dart.notNull(addCount) - endSpace;
              this[_table][dartx.setRange](this[_tail], dart.notNull(this[_tail]) + endSpace, list, 0);
              this[_table][dartx.setRange](0, preSpace, list, endSpace);
              this[_tail] = preSpace;
            }
          }
        } else {
          for (let element of elements)
            this[_add$](element);
        }
      }
      toString() {
        return collection.IterableBase.iterableToFullString(this, "{", "}");
      }
      addLast(element) {
        dart.as(element, E);
        this[_add$](element);
      }
      addFirst(element) {
        dart.as(element, E);
        this[_head] = dart.notNull(this[_head]) - 1 & dart.notNull(this[_table][dartx.length]) - 1;
        this[_table][dartx.set](this[_head], element);
        if (this[_head] == this[_tail]) this[_grow$]();
      }
      removeFirst() {
        if (this[_head] == this[_tail]) dart.throw(new core.StateError("No element"));
        let result = this[_table][dartx.get](this[_head]);
        this[_table][dartx.set](this[_head], null);
        this[_head] = dart.notNull(this[_head]) + 1 & dart.notNull(this[_table][dartx.length]) - 1;
        return result;
      }
      removeLast() {
        if (this[_head] == this[_tail]) dart.throw(new core.StateError("No element"));
        this[_tail] = dart.notNull(this[_tail]) - 1 & dart.notNull(this[_table][dartx.length]) - 1;
        let result = this[_table][dartx.get](this[_tail]);
        this[_table][dartx.set](this[_tail], null);
        return result;
      }
      get length() {
        return dart.notNull(this[_tail]) - dart.notNull(this[_head]) & dart.notNull(this[_table][dartx.length]) - 1;
      }
      set length(value) {
        if (dart.notNull(value) < 0) dart.throw(new core.RangeError(`Length ${value} may not be negative.`));
        let delta = dart.notNull(value) - dart.notNull(this.length);
        if (delta >= 0) {
          if (dart.notNull(this[_table][dartx.length]) <= dart.notNull(value)) {
            this[_preGrow](value);
          }
          this[_tail] = dart.notNull(this[_tail]) + delta & dart.notNull(this[_table][dartx.length]) - 1;
          return;
        }
        let newTail = dart.notNull(this[_tail]) + delta;
        if (dart.notNull(newTail) >= 0) {
          this[_table][dartx.fillRange](newTail, this[_tail], null);
        } else {
          newTail = dart.notNull(newTail) + dart.notNull(this[_table][dartx.length]);
          this[_table][dartx.fillRange](0, this[_tail], null);
          this[_table][dartx.fillRange](newTail, this[_table][dartx.length], null);
        }
        this[_tail] = newTail;
      }
      get(index) {
        if (dart.notNull(index) < 0 || dart.notNull(index) >= dart.notNull(this.length)) {
          dart.throw(new core.RangeError(`Index ${index} must be in the range [0..${this.length}).`));
        }
        return this[_table][dartx.get](dart.notNull(this[_head]) + dart.notNull(index) & dart.notNull(this[_table][dartx.length]) - 1);
      }
      set(index, value) {
        dart.as(value, E);
        if (dart.notNull(index) < 0 || dart.notNull(index) >= dart.notNull(this.length)) {
          dart.throw(new core.RangeError(`Index ${index} must be in the range [0..${this.length}).`));
        }
        this[_table][dartx.set](dart.notNull(this[_head]) + dart.notNull(index) & dart.notNull(this[_table][dartx.length]) - 1, value);
        return value;
      }
      static _isPowerOf2(number) {
        return (dart.notNull(number) & dart.notNull(number) - 1) == 0;
      }
      static _nextPowerOf2(number) {
        dart.assert(dart.notNull(number) > 0);
        number = (dart.notNull(number) << 1) - 1;
        for (;;) {
          let nextNumber = dart.notNull(number) & dart.notNull(number) - 1;
          if (nextNumber == 0) return number;
          number = nextNumber;
        }
      }
      [_add$](element) {
        dart.as(element, E);
        this[_table][dartx.set](this[_tail], element);
        this[_tail] = dart.notNull(this[_tail]) + 1 & dart.notNull(this[_table][dartx.length]) - 1;
        if (this[_head] == this[_tail]) this[_grow$]();
      }
      [_grow$]() {
        let newTable = core.List$(E).new(dart.notNull(this[_table][dartx.length]) * 2);
        let split = dart.notNull(this[_table][dartx.length]) - dart.notNull(this[_head]);
        newTable[dartx.setRange](0, split, this[_table], this[_head]);
        newTable[dartx.setRange](split, split + dart.notNull(this[_head]), this[_table], 0);
        this[_head] = 0;
        this[_tail] = this[_table][dartx.length];
        this[_table] = newTable;
      }
      [_writeToList](target) {
        dart.as(target, core.List$(E));
        dart.assert(dart.notNull(target[dartx.length]) >= dart.notNull(this.length));
        if (dart.notNull(this[_head]) <= dart.notNull(this[_tail])) {
          let length = dart.notNull(this[_tail]) - dart.notNull(this[_head]);
          target[dartx.setRange](0, length, this[_table], this[_head]);
          return length;
        } else {
          let firstPartSize = dart.notNull(this[_table][dartx.length]) - dart.notNull(this[_head]);
          target[dartx.setRange](0, firstPartSize, this[_table], this[_head]);
          target[dartx.setRange](firstPartSize, firstPartSize + dart.notNull(this[_tail]), this[_table], 0);
          return dart.notNull(this[_tail]) + firstPartSize;
        }
      }
      [_preGrow](newElementCount) {
        dart.assert(dart.notNull(newElementCount) >= dart.notNull(this.length));
        newElementCount = dart.notNull(newElementCount) + (dart.notNull(newElementCount) >> 1);
        let newCapacity = queue_list.QueueList._nextPowerOf2(newElementCount);
        let newTable = core.List$(E).new(newCapacity);
        this[_tail] = this[_writeToList](newTable);
        this[_table] = newTable;
        this[_head] = 0;
      }
    }
    QueueList[dart.implements] = () => [collection.Queue$(E)];
    dart.setSignature(QueueList, {
      constructors: () => ({
        QueueList: [queue_list.QueueList$(E), [], [core.int]],
        from: [queue_list.QueueList$(E), [core.Iterable$(E)]]
      }),
      methods: () => ({
        add: [dart.void, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        addLast: [dart.void, [E]],
        addFirst: [dart.void, [E]],
        removeFirst: [E, []],
        removeLast: [E, []],
        get: [E, [core.int]],
        set: [dart.void, [core.int, E]],
        [_add$]: [dart.void, [E]],
        [_grow$]: [dart.void, []],
        [_writeToList]: [core.int, [core.List$(E)]],
        [_preGrow]: [dart.void, [core.int]]
      }),
      statics: () => ({
        _isPowerOf2: [core.bool, [core.int]],
        _nextPowerOf2: [core.int, [core.int]]
      }),
      names: ['_isPowerOf2', '_nextPowerOf2']
    });
    dart.defineExtensionMembers(QueueList, [
      'add',
      'addAll',
      'toString',
      'removeLast',
      'get',
      'set',
      'length',
      'length'
    ]);
    return QueueList;
  });
  queue_list.QueueList = queue_list.QueueList$();
  queue_list.QueueList._INITIAL_CAPACITY = 8;
  collection$.QueueList$ = queue_list.QueueList$;
  collection$.QueueList = queue_list.QueueList;
  unmodifiable_wrappers.UnmodifiableSetMixin$ = dart.generic(E => {
    class UnmodifiableSetMixin extends core.Object {
      static _throw() {
        dart.throw(new core.UnsupportedError("Cannot modify an unmodifiable Set"));
      }
      add(value) {
        dart.as(value, E);
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
      addAll(elements) {
        dart.as(elements, core.Iterable$(E));
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
      remove(value) {
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
      removeAll(elements) {
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
      retainAll(elements) {
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
      clear() {
        return unmodifiable_wrappers.UnmodifiableSetMixin._throw();
      }
    }
    UnmodifiableSetMixin[dart.implements] = () => [core.Set$(E)];
    dart.setSignature(UnmodifiableSetMixin, {
      methods: () => ({
        add: [core.bool, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        remove: [core.bool, [core.Object]],
        removeAll: [dart.void, [core.Iterable]],
        retainAll: [dart.void, [core.Iterable]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        clear: [dart.void, []]
      }),
      statics: () => ({_throw: [dart.dynamic, []]}),
      names: ['_throw']
    });
    return UnmodifiableSetMixin;
  });
  unmodifiable_wrappers.UnmodifiableSetMixin = unmodifiable_wrappers.UnmodifiableSetMixin$();
  collection$.UnmodifiableSetMixin$ = unmodifiable_wrappers.UnmodifiableSetMixin$;
  collection$.UnmodifiableSetMixin = unmodifiable_wrappers.UnmodifiableSetMixin;
  collection$.UnmodifiableListView$ = collection.UnmodifiableListView$;
  collection$.UnmodifiableListView = collection.UnmodifiableListView;
  const _base$0 = Symbol('_base');
  const _setBase = Symbol('_setBase');
  wrappers._DelegatingIterableBase$ = dart.generic(E => {
    class _DelegatingIterableBase extends core.Object {
      _DelegatingIterableBase() {
      }
      any(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$0][dartx.any](test);
      }
      contains(element) {
        return this[_base$0][dartx.contains](element);
      }
      elementAt(index) {
        return this[_base$0][dartx.elementAt](index);
      }
      every(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$0][dartx.every](test);
      }
      expand(f) {
        dart.as(f, dart.functionType(core.Iterable, [E]));
        return this[_base$0][dartx.expand](f);
      }
      get first() {
        return this[_base$0][dartx.first];
      }
      firstWhere(test, opts) {
        dart.as(test, dart.functionType(core.bool, [E]));
        let orElse = opts && 'orElse' in opts ? opts.orElse : null;
        dart.as(orElse, dart.functionType(E, []));
        return this[_base$0][dartx.firstWhere](test, {orElse: orElse});
      }
      fold(initialValue, combine) {
        dart.as(combine, dart.functionType(dart.dynamic, [dart.dynamic, E]));
        return this[_base$0][dartx.fold](initialValue, combine);
      }
      forEach(f) {
        dart.as(f, dart.functionType(dart.void, [E]));
        return this[_base$0][dartx.forEach](f);
      }
      get isEmpty() {
        return this[_base$0][dartx.isEmpty];
      }
      get isNotEmpty() {
        return this[_base$0][dartx.isNotEmpty];
      }
      get iterator() {
        return this[_base$0][dartx.iterator];
      }
      [Symbol.iterator]() {
        return new dart.JsIterator(this.iterator);
      }
      join(separator) {
        if (separator === void 0) separator = "";
        return this[_base$0][dartx.join](separator);
      }
      get last() {
        return this[_base$0][dartx.last];
      }
      lastWhere(test, opts) {
        dart.as(test, dart.functionType(core.bool, [E]));
        let orElse = opts && 'orElse' in opts ? opts.orElse : null;
        dart.as(orElse, dart.functionType(E, []));
        return this[_base$0][dartx.lastWhere](test, {orElse: orElse});
      }
      get length() {
        return this[_base$0][dartx.length];
      }
      map(f) {
        dart.as(f, dart.functionType(dart.dynamic, [E]));
        return this[_base$0][dartx.map](f);
      }
      reduce(combine) {
        dart.as(combine, dart.functionType(E, [E, E]));
        return this[_base$0][dartx.reduce](combine);
      }
      get single() {
        return this[_base$0][dartx.single];
      }
      singleWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$0][dartx.singleWhere](test);
      }
      skip(n) {
        return this[_base$0][dartx.skip](n);
      }
      skipWhile(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$0][dartx.skipWhile](test);
      }
      take(n) {
        return this[_base$0][dartx.take](n);
      }
      takeWhile(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$0][dartx.takeWhile](test);
      }
      toList(opts) {
        let growable = opts && 'growable' in opts ? opts.growable : true;
        return this[_base$0][dartx.toList]({growable: growable});
      }
      toSet() {
        return this[_base$0][dartx.toSet]();
      }
      where(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$0][dartx.where](test);
      }
      toString() {
        return dart.toString(this[_base$0]);
      }
    }
    _DelegatingIterableBase[dart.implements] = () => [core.Iterable$(E)];
    dart.setSignature(_DelegatingIterableBase, {
      constructors: () => ({_DelegatingIterableBase: [wrappers._DelegatingIterableBase$(E), []]}),
      methods: () => ({
        any: [core.bool, [dart.functionType(core.bool, [E])]],
        contains: [core.bool, [core.Object]],
        elementAt: [E, [core.int]],
        every: [core.bool, [dart.functionType(core.bool, [E])]],
        expand: [core.Iterable, [dart.functionType(core.Iterable, [E])]],
        firstWhere: [E, [dart.functionType(core.bool, [E])], {orElse: dart.functionType(E, [])}],
        fold: [dart.dynamic, [dart.dynamic, dart.functionType(dart.dynamic, [dart.dynamic, E])]],
        forEach: [dart.void, [dart.functionType(dart.void, [E])]],
        join: [core.String, [], [core.String]],
        lastWhere: [E, [dart.functionType(core.bool, [E])], {orElse: dart.functionType(E, [])}],
        map: [core.Iterable, [dart.functionType(dart.dynamic, [E])]],
        reduce: [E, [dart.functionType(E, [E, E])]],
        singleWhere: [E, [dart.functionType(core.bool, [E])]],
        skip: [core.Iterable$(E), [core.int]],
        skipWhile: [core.Iterable$(E), [dart.functionType(core.bool, [E])]],
        take: [core.Iterable$(E), [core.int]],
        takeWhile: [core.Iterable$(E), [dart.functionType(core.bool, [E])]],
        toList: [core.List$(E), [], {growable: core.bool}],
        toSet: [core.Set$(E), []],
        where: [core.Iterable$(E), [dart.functionType(core.bool, [E])]]
      })
    });
    dart.defineExtensionMembers(_DelegatingIterableBase, [
      'any',
      'contains',
      'elementAt',
      'every',
      'expand',
      'firstWhere',
      'fold',
      'forEach',
      'join',
      'lastWhere',
      'map',
      'reduce',
      'singleWhere',
      'skip',
      'skipWhile',
      'take',
      'takeWhile',
      'toList',
      'toSet',
      'where',
      'toString',
      'first',
      'isEmpty',
      'isNotEmpty',
      'iterator',
      'last',
      'length',
      'single'
    ]);
    return _DelegatingIterableBase;
  });
  wrappers._DelegatingIterableBase = wrappers._DelegatingIterableBase$();
  wrappers.DelegatingIterable$ = dart.generic(E => {
    class DelegatingIterable extends wrappers._DelegatingIterableBase$(E) {
      DelegatingIterable(base) {
        this[_base$0] = base;
        super._DelegatingIterableBase();
      }
      static typed(base) {
        return dart.is(base, core.Iterable) ? base : new typed_wrappers.TypeSafeIterable(base);
      }
    }
    dart.setSignature(DelegatingIterable, {
      constructors: () => ({DelegatingIterable: [wrappers.DelegatingIterable$(E), [core.Iterable$(E)]]}),
      statics: () => ({typed: [core.Iterable, [core.Iterable]]}),
      names: ['typed']
    });
    return DelegatingIterable;
  });
  wrappers.DelegatingIterable = wrappers.DelegatingIterable$();
  wrappers.DelegatingSet$ = dart.generic(E => {
    class DelegatingSet extends wrappers.DelegatingIterable$(E) {
      DelegatingSet(base) {
        super.DelegatingIterable(base);
      }
      static typed(base) {
        return dart.is(base, core.Set) ? base : new typed_wrappers.TypeSafeSet(base);
      }
      get [_setBase]() {
        return dart.as(this[_base$0], core.Set$(E));
      }
      add(value) {
        dart.as(value, E);
        return this[_setBase].add(value);
      }
      addAll(elements) {
        dart.as(elements, core.Iterable$(E));
        this[_setBase].addAll(elements);
      }
      clear() {
        this[_setBase].clear();
      }
      containsAll(other) {
        return this[_setBase].containsAll(other);
      }
      difference(other) {
        dart.as(other, core.Set$(E));
        return this[_setBase].difference(other);
      }
      intersection(other) {
        return this[_setBase].intersection(other);
      }
      lookup(element) {
        return this[_setBase].lookup(element);
      }
      remove(value) {
        return this[_setBase].remove(value);
      }
      removeAll(elements) {
        this[_setBase].removeAll(elements);
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_setBase].removeWhere(test);
      }
      retainAll(elements) {
        this[_setBase].retainAll(elements);
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_setBase].retainWhere(test);
      }
      union(other) {
        dart.as(other, core.Set$(E));
        return this[_setBase].union(other);
      }
      toSet() {
        return new (wrappers.DelegatingSet$(E))(this[_setBase].toSet());
      }
    }
    DelegatingSet[dart.implements] = () => [core.Set$(E)];
    dart.setSignature(DelegatingSet, {
      constructors: () => ({DelegatingSet: [wrappers.DelegatingSet$(E), [core.Set$(E)]]}),
      methods: () => ({
        add: [core.bool, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        clear: [dart.void, []],
        containsAll: [core.bool, [core.Iterable$(core.Object)]],
        difference: [core.Set$(E), [core.Set$(E)]],
        intersection: [core.Set$(E), [core.Set$(core.Object)]],
        lookup: [E, [core.Object]],
        remove: [core.bool, [core.Object]],
        removeAll: [dart.void, [core.Iterable$(core.Object)]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        retainAll: [dart.void, [core.Iterable$(core.Object)]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        union: [core.Set$(E), [core.Set$(E)]],
        toSet: [core.Set$(E), []]
      }),
      statics: () => ({typed: [core.Set, [core.Set]]}),
      names: ['typed']
    });
    dart.defineExtensionMembers(DelegatingSet, ['toSet']);
    return DelegatingSet;
  });
  wrappers.DelegatingSet = wrappers.DelegatingSet$();
  unmodifiable_wrappers.UnmodifiableSetView$ = dart.generic(E => {
    class UnmodifiableSetView extends dart.mixin(wrappers.DelegatingSet$(E), unmodifiable_wrappers.UnmodifiableSetMixin$(E)) {
      UnmodifiableSetView(setBase) {
        super.DelegatingSet(setBase);
      }
    }
    dart.setSignature(UnmodifiableSetView, {
      constructors: () => ({UnmodifiableSetView: [unmodifiable_wrappers.UnmodifiableSetView$(E), [core.Set$(E)]]})
    });
    return UnmodifiableSetView;
  });
  unmodifiable_wrappers.UnmodifiableSetView = unmodifiable_wrappers.UnmodifiableSetView$();
  collection$.UnmodifiableSetView$ = unmodifiable_wrappers.UnmodifiableSetView$;
  collection$.UnmodifiableSetView = unmodifiable_wrappers.UnmodifiableSetView;
  collection$.UnmodifiableMapView$ = collection.UnmodifiableMapView$;
  collection$.UnmodifiableMapView = collection.UnmodifiableMapView;
  unmodifiable_wrappers.NonGrowableListMixin$ = dart.generic(E => {
    class NonGrowableListMixin extends core.Object {
      static _throw() {
        dart.throw(new core.UnsupportedError("Cannot change the length of a fixed-length list"));
      }
      set length(newLength) {
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      add(value) {
        dart.as(value, E);
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      addAll(iterable) {
        dart.as(iterable, core.Iterable$(E));
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      insert(index, element) {
        dart.as(element, E);
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      insertAll(index, iterable) {
        dart.as(iterable, core.Iterable$(E));
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      remove(value) {
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      removeAt(index) {
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      removeLast() {
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      removeRange(start, end) {
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      replaceRange(start, end, iterable) {
        dart.as(iterable, core.Iterable$(E));
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
      clear() {
        return unmodifiable_wrappers.NonGrowableListMixin._throw();
      }
    }
    NonGrowableListMixin[dart.implements] = () => [core.List$(E)];
    dart.setSignature(NonGrowableListMixin, {
      methods: () => ({
        add: [core.bool, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        insert: [dart.void, [core.int, E]],
        insertAll: [dart.void, [core.int, core.Iterable$(E)]],
        remove: [core.bool, [core.Object]],
        removeAt: [E, [core.int]],
        removeLast: [E, []],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        removeRange: [dart.void, [core.int, core.int]],
        replaceRange: [dart.void, [core.int, core.int, core.Iterable$(E)]],
        clear: [dart.void, []]
      }),
      statics: () => ({_throw: [dart.dynamic, []]}),
      names: ['_throw']
    });
    dart.defineExtensionMembers(NonGrowableListMixin, [
      'add',
      'addAll',
      'insert',
      'insertAll',
      'remove',
      'removeAt',
      'removeLast',
      'removeWhere',
      'retainWhere',
      'removeRange',
      'replaceRange',
      'clear',
      'length'
    ]);
    return NonGrowableListMixin;
  });
  unmodifiable_wrappers.NonGrowableListMixin = unmodifiable_wrappers.NonGrowableListMixin$();
  collection$.NonGrowableListMixin$ = unmodifiable_wrappers.NonGrowableListMixin$;
  collection$.NonGrowableListMixin = unmodifiable_wrappers.NonGrowableListMixin;
  unmodifiable_wrappers.UnmodifiableMapMixin$ = dart.generic((K, V) => {
    class UnmodifiableMapMixin extends core.Object {
      static _throw() {
        dart.throw(new core.UnsupportedError("Cannot modify an unmodifiable Map"));
      }
      set(key, value) {
        (() => {
          dart.as(key, K);
          dart.as(value, V);
          return unmodifiable_wrappers.UnmodifiableMapMixin._throw();
        })();
        return value;
      }
      putIfAbsent(key, ifAbsent) {
        dart.as(key, K);
        dart.as(ifAbsent, dart.functionType(V, []));
        return unmodifiable_wrappers.UnmodifiableMapMixin._throw();
      }
      addAll(other) {
        dart.as(other, core.Map$(K, V));
        return unmodifiable_wrappers.UnmodifiableMapMixin._throw();
      }
      remove(key) {
        return unmodifiable_wrappers.UnmodifiableMapMixin._throw();
      }
      clear() {
        return unmodifiable_wrappers.UnmodifiableMapMixin._throw();
      }
    }
    UnmodifiableMapMixin[dart.implements] = () => [core.Map$(K, V)];
    dart.setSignature(UnmodifiableMapMixin, {
      methods: () => ({
        set: [dart.void, [K, V]],
        putIfAbsent: [V, [K, dart.functionType(V, [])]],
        addAll: [dart.void, [core.Map$(K, V)]],
        remove: [V, [core.Object]],
        clear: [dart.void, []]
      }),
      statics: () => ({_throw: [dart.dynamic, []]}),
      names: ['_throw']
    });
    dart.defineExtensionMembers(UnmodifiableMapMixin, [
      'set',
      'putIfAbsent',
      'addAll',
      'remove',
      'clear'
    ]);
    return UnmodifiableMapMixin;
  });
  unmodifiable_wrappers.UnmodifiableMapMixin = unmodifiable_wrappers.UnmodifiableMapMixin$();
  collection$.UnmodifiableMapMixin$ = unmodifiable_wrappers.UnmodifiableMapMixin$;
  collection$.UnmodifiableMapMixin = unmodifiable_wrappers.UnmodifiableMapMixin;
  const _listBase = Symbol('_listBase');
  wrappers.DelegatingList$ = dart.generic(E => {
    class DelegatingList extends wrappers.DelegatingIterable$(E) {
      DelegatingList(base) {
        super.DelegatingIterable(base);
      }
      static typed(base) {
        return dart.is(base, core.List) ? base : new typed_wrappers.TypeSafeList(base);
      }
      get [_listBase]() {
        return dart.as(this[_base$0], core.List$(E));
      }
      get(index) {
        return this[_listBase][dartx.get](index);
      }
      set(index, value) {
        dart.as(value, E);
        this[_listBase][dartx.set](index, value);
        return value;
      }
      add(value) {
        dart.as(value, E);
        this[_listBase][dartx.add](value);
      }
      addAll(iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase][dartx.addAll](iterable);
      }
      asMap() {
        return this[_listBase][dartx.asMap]();
      }
      clear() {
        this[_listBase][dartx.clear]();
      }
      fillRange(start, end, fillValue) {
        if (fillValue === void 0) fillValue = null;
        dart.as(fillValue, E);
        this[_listBase][dartx.fillRange](start, end, fillValue);
      }
      getRange(start, end) {
        return this[_listBase][dartx.getRange](start, end);
      }
      indexOf(element, start) {
        dart.as(element, E);
        if (start === void 0) start = 0;
        return this[_listBase][dartx.indexOf](element, start);
      }
      insert(index, element) {
        dart.as(element, E);
        this[_listBase][dartx.insert](index, element);
      }
      insertAll(index, iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase][dartx.insertAll](index, iterable);
      }
      lastIndexOf(element, start) {
        dart.as(element, E);
        if (start === void 0) start = null;
        return this[_listBase][dartx.lastIndexOf](element, start);
      }
      set length(newLength) {
        this[_listBase][dartx.length] = newLength;
      }
      remove(value) {
        return this[_listBase][dartx.remove](value);
      }
      removeAt(index) {
        return this[_listBase][dartx.removeAt](index);
      }
      removeLast() {
        return this[_listBase][dartx.removeLast]();
      }
      removeRange(start, end) {
        this[_listBase][dartx.removeRange](start, end);
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_listBase][dartx.removeWhere](test);
      }
      replaceRange(start, end, iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase][dartx.replaceRange](start, end, iterable);
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_listBase][dartx.retainWhere](test);
      }
      get reversed() {
        return this[_listBase][dartx.reversed];
      }
      setAll(index, iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase][dartx.setAll](index, iterable);
      }
      setRange(start, end, iterable, skipCount) {
        dart.as(iterable, core.Iterable$(E));
        if (skipCount === void 0) skipCount = 0;
        this[_listBase][dartx.setRange](start, end, iterable, skipCount);
      }
      shuffle(random) {
        if (random === void 0) random = null;
        this[_listBase][dartx.shuffle](random);
      }
      sort(compare) {
        if (compare === void 0) compare = null;
        dart.as(compare, dart.functionType(core.int, [E, E]));
        this[_listBase][dartx.sort](compare);
      }
      sublist(start, end) {
        if (end === void 0) end = null;
        return this[_listBase][dartx.sublist](start, end);
      }
    }
    DelegatingList[dart.implements] = () => [core.List$(E)];
    dart.setSignature(DelegatingList, {
      constructors: () => ({DelegatingList: [wrappers.DelegatingList$(E), [core.List$(E)]]}),
      methods: () => ({
        get: [E, [core.int]],
        set: [dart.void, [core.int, E]],
        add: [dart.void, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        asMap: [core.Map$(core.int, E), []],
        clear: [dart.void, []],
        fillRange: [dart.void, [core.int, core.int], [E]],
        getRange: [core.Iterable$(E), [core.int, core.int]],
        indexOf: [core.int, [E], [core.int]],
        insert: [dart.void, [core.int, E]],
        insertAll: [dart.void, [core.int, core.Iterable$(E)]],
        lastIndexOf: [core.int, [E], [core.int]],
        remove: [core.bool, [core.Object]],
        removeAt: [E, [core.int]],
        removeLast: [E, []],
        removeRange: [dart.void, [core.int, core.int]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        replaceRange: [dart.void, [core.int, core.int, core.Iterable$(E)]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        setAll: [dart.void, [core.int, core.Iterable$(E)]],
        setRange: [dart.void, [core.int, core.int, core.Iterable$(E)], [core.int]],
        shuffle: [dart.void, [], [math.Random]],
        sort: [dart.void, [], [dart.functionType(core.int, [E, E])]],
        sublist: [core.List$(E), [core.int], [core.int]]
      }),
      statics: () => ({typed: [core.List, [core.List]]}),
      names: ['typed']
    });
    dart.defineExtensionMembers(DelegatingList, [
      'get',
      'set',
      'add',
      'addAll',
      'asMap',
      'clear',
      'fillRange',
      'getRange',
      'indexOf',
      'insert',
      'insertAll',
      'lastIndexOf',
      'remove',
      'removeAt',
      'removeLast',
      'removeRange',
      'removeWhere',
      'replaceRange',
      'retainWhere',
      'setAll',
      'setRange',
      'shuffle',
      'sort',
      'sublist',
      'length',
      'reversed'
    ]);
    return DelegatingList;
  });
  wrappers.DelegatingList = wrappers.DelegatingList$();
  unmodifiable_wrappers.NonGrowableListView$ = dart.generic(E => {
    class NonGrowableListView extends dart.mixin(wrappers.DelegatingList$(E), unmodifiable_wrappers.NonGrowableListMixin$(E)) {
      NonGrowableListView(listBase) {
        super.DelegatingList(listBase);
      }
    }
    dart.setSignature(NonGrowableListView, {
      constructors: () => ({NonGrowableListView: [unmodifiable_wrappers.NonGrowableListView$(E), [core.List$(E)]]})
    });
    return NonGrowableListView;
  });
  unmodifiable_wrappers.NonGrowableListView = unmodifiable_wrappers.NonGrowableListView$();
  collection$.NonGrowableListView$ = unmodifiable_wrappers.NonGrowableListView$;
  collection$.NonGrowableListView = unmodifiable_wrappers.NonGrowableListView;
  collection$.DelegatingIterable$ = wrappers.DelegatingIterable$;
  collection$.DelegatingIterable = wrappers.DelegatingIterable;
  collection$.DelegatingSet$ = wrappers.DelegatingSet$;
  collection$.DelegatingSet = wrappers.DelegatingSet;
  const _baseQueue = Symbol('_baseQueue');
  wrappers.DelegatingQueue$ = dart.generic(E => {
    class DelegatingQueue extends wrappers.DelegatingIterable$(E) {
      DelegatingQueue(queue) {
        super.DelegatingIterable(queue);
      }
      static typed(base) {
        return dart.is(base, collection.Queue) ? base : new typed_wrappers.TypeSafeQueue(base);
      }
      get [_baseQueue]() {
        return dart.as(this[_base$0], collection.Queue$(E));
      }
      add(value) {
        dart.as(value, E);
        this[_baseQueue].add(value);
      }
      addAll(iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_baseQueue].addAll(iterable);
      }
      addFirst(value) {
        dart.as(value, E);
        this[_baseQueue].addFirst(value);
      }
      addLast(value) {
        dart.as(value, E);
        this[_baseQueue].addLast(value);
      }
      clear() {
        this[_baseQueue].clear();
      }
      remove(object) {
        return this[_baseQueue].remove(object);
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_baseQueue].removeWhere(test);
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_baseQueue].retainWhere(test);
      }
      removeFirst() {
        return this[_baseQueue].removeFirst();
      }
      removeLast() {
        return this[_baseQueue].removeLast();
      }
    }
    DelegatingQueue[dart.implements] = () => [collection.Queue$(E)];
    dart.setSignature(DelegatingQueue, {
      constructors: () => ({DelegatingQueue: [wrappers.DelegatingQueue$(E), [collection.Queue$(E)]]}),
      methods: () => ({
        add: [dart.void, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        addFirst: [dart.void, [E]],
        addLast: [dart.void, [E]],
        clear: [dart.void, []],
        remove: [core.bool, [core.Object]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        removeFirst: [E, []],
        removeLast: [E, []]
      }),
      statics: () => ({typed: [collection.Queue, [collection.Queue]]}),
      names: ['typed']
    });
    return DelegatingQueue;
  });
  wrappers.DelegatingQueue = wrappers.DelegatingQueue$();
  collection$.DelegatingQueue$ = wrappers.DelegatingQueue$;
  collection$.DelegatingQueue = wrappers.DelegatingQueue;
  const _baseMap = Symbol('_baseMap');
  wrappers.MapKeySet$ = dart.generic(E => {
    class MapKeySet extends dart.mixin(wrappers._DelegatingIterableBase$(E), unmodifiable_wrappers.UnmodifiableSetMixin$(E)) {
      MapKeySet(base) {
        this[_baseMap] = base;
        super._DelegatingIterableBase();
      }
      get [_base$0]() {
        return this[_baseMap][dartx.keys];
      }
      contains(element) {
        return this[_baseMap][dartx.containsKey](element);
      }
      get isEmpty() {
        return this[_baseMap][dartx.isEmpty];
      }
      get isNotEmpty() {
        return this[_baseMap][dartx.isNotEmpty];
      }
      get length() {
        return this[_baseMap][dartx.length];
      }
      toString() {
        return `{${this[_base$0][dartx.join](', ')}}`;
      }
      containsAll(other) {
        return other[dartx.every](dart.bind(this, 'contains'));
      }
      difference(other) {
        dart.as(other, core.Set$(E));
        return this.where(dart.fn(element => {
          dart.as(element, E);
          return !dart.notNull(other.contains(element));
        }, core.bool, [E]))[dartx.toSet]();
      }
      intersection(other) {
        return this.where(dart.bind(other, 'contains'))[dartx.toSet]();
      }
      lookup(element) {
        dart.as(element, E);
        return dart.throw(new core.UnsupportedError("MapKeySet doesn't support lookup()."));
      }
      union(other) {
        dart.as(other, core.Set$(E));
        return (() => {
          let _ = this.toSet();
          _.addAll(other);
          return _;
        })();
      }
    }
    dart.setSignature(MapKeySet, {
      constructors: () => ({MapKeySet: [wrappers.MapKeySet$(E), [core.Map$(E, dart.dynamic)]]}),
      methods: () => ({
        containsAll: [core.bool, [core.Iterable$(core.Object)]],
        difference: [core.Set$(E), [core.Set$(E)]],
        intersection: [core.Set$(E), [core.Set$(core.Object)]],
        lookup: [E, [E]],
        union: [core.Set$(E), [core.Set$(E)]]
      })
    });
    dart.defineExtensionMembers(MapKeySet, [
      'contains',
      'toString',
      'isEmpty',
      'isNotEmpty',
      'length'
    ]);
    return MapKeySet;
  });
  wrappers.MapKeySet = wrappers.MapKeySet$();
  collection$.MapKeySet$ = wrappers.MapKeySet$;
  collection$.MapKeySet = wrappers.MapKeySet;
  collection$.DelegatingList$ = wrappers.DelegatingList$;
  collection$.DelegatingList = wrappers.DelegatingList;
  const _keyForValue = Symbol('_keyForValue');
  wrappers.MapValueSet$ = dart.generic((K, V) => {
    class MapValueSet extends wrappers._DelegatingIterableBase$(V) {
      MapValueSet(base, keyForValue) {
        this[_baseMap] = base;
        this[_keyForValue] = keyForValue;
        super._DelegatingIterableBase();
      }
      get [_base$0]() {
        return this[_baseMap][dartx.values];
      }
      contains(element) {
        if (element != null && !dart.is(element, V)) return false;
        let key = this[_keyForValue](dart.as(element, V));
        return this[_baseMap][dartx.containsKey](key);
      }
      get isEmpty() {
        return this[_baseMap][dartx.isEmpty];
      }
      get isNotEmpty() {
        return this[_baseMap][dartx.isNotEmpty];
      }
      get length() {
        return this[_baseMap][dartx.length];
      }
      toString() {
        return dart.toString(this.toSet());
      }
      add(value) {
        dart.as(value, V);
        let key = this[_keyForValue](value);
        let result = false;
        this[_baseMap][dartx.putIfAbsent](key, dart.fn(() => {
          result = true;
          return value;
        }, V, []));
        return result;
      }
      addAll(elements) {
        dart.as(elements, core.Iterable$(V));
        return elements[dartx.forEach](dart.bind(this, 'add'));
      }
      clear() {
        return this[_baseMap][dartx.clear]();
      }
      containsAll(other) {
        return other[dartx.every](dart.bind(this, 'contains'));
      }
      difference(other) {
        dart.as(other, core.Set$(V));
        return this.where(dart.fn(element => {
          dart.as(element, V);
          return !dart.notNull(other.contains(element));
        }, core.bool, [V]))[dartx.toSet]();
      }
      intersection(other) {
        return this.where(dart.bind(other, 'contains'))[dartx.toSet]();
      }
      lookup(element) {
        if (element != null && !dart.is(element, V)) return null;
        let key = this[_keyForValue](dart.as(element, V));
        return this[_baseMap][dartx.get](key);
      }
      remove(element) {
        if (element != null && !dart.is(element, V)) return false;
        let key = this[_keyForValue](dart.as(element, V));
        if (!dart.notNull(this[_baseMap][dartx.containsKey](key))) return false;
        this[_baseMap][dartx.remove](key);
        return true;
      }
      removeAll(elements) {
        return elements[dartx.forEach](dart.bind(this, 'remove'));
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [V]));
        let toRemove = [];
        this[_baseMap][dartx.forEach](dart.fn((key, value) => {
          dart.as(key, K);
          dart.as(value, V);
          if (dart.notNull(test(value))) toRemove[dartx.add](key);
        }, dart.void, [K, V]));
        toRemove[dartx.forEach](dart.bind(this[_baseMap], dartx.remove));
      }
      retainAll(elements) {
        let valuesToRetain = core.Set$(V).identity();
        for (let element of elements) {
          if (element != null && !dart.is(element, V)) continue;
          let key = this[_keyForValue](dart.as(element, V));
          if (!dart.notNull(this[_baseMap][dartx.containsKey](key))) continue;
          valuesToRetain.add(this[_baseMap][dartx.get](key));
        }
        let keysToRemove = [];
        this[_baseMap][dartx.forEach](dart.fn((k, v) => {
          dart.as(k, K);
          dart.as(v, V);
          if (!dart.notNull(valuesToRetain.contains(v))) keysToRemove[dartx.add](k);
        }, dart.void, [K, V]));
        keysToRemove[dartx.forEach](dart.bind(this[_baseMap], dartx.remove));
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [V]));
        return this.removeWhere(dart.fn(element => {
          dart.as(element, V);
          return !dart.notNull(test(element));
        }, core.bool, [V]));
      }
      union(other) {
        dart.as(other, core.Set$(V));
        return (() => {
          let _ = this.toSet();
          _.addAll(other);
          return _;
        })();
      }
    }
    MapValueSet[dart.implements] = () => [core.Set$(V)];
    dart.setSignature(MapValueSet, {
      constructors: () => ({MapValueSet: [wrappers.MapValueSet$(K, V), [core.Map$(K, V), dart.functionType(K, [V])]]}),
      methods: () => ({
        add: [core.bool, [V]],
        addAll: [dart.void, [core.Iterable$(V)]],
        clear: [dart.void, []],
        containsAll: [core.bool, [core.Iterable$(core.Object)]],
        difference: [core.Set$(V), [core.Set$(V)]],
        intersection: [core.Set$(V), [core.Set$(core.Object)]],
        lookup: [V, [core.Object]],
        remove: [core.bool, [core.Object]],
        removeAll: [dart.void, [core.Iterable$(core.Object)]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [V])]],
        retainAll: [dart.void, [core.Iterable$(core.Object)]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [V])]],
        union: [core.Set$(V), [core.Set$(V)]]
      })
    });
    dart.defineExtensionMembers(MapValueSet, [
      'contains',
      'toString',
      'isEmpty',
      'isNotEmpty',
      'length'
    ]);
    return MapValueSet;
  });
  wrappers.MapValueSet = wrappers.MapValueSet$();
  collection$.MapValueSet$ = wrappers.MapValueSet$;
  collection$.MapValueSet = wrappers.MapValueSet;
  wrappers.DelegatingMap$ = dart.generic((K, V) => {
    class DelegatingMap extends core.Object {
      DelegatingMap(base) {
        this[_base$0] = base;
      }
      static typed(base) {
        return dart.is(base, core.Map) ? base : new typed_wrappers.TypeSafeMap(base);
      }
      get(key) {
        return this[_base$0][dartx.get](key);
      }
      set(key, value) {
        dart.as(key, K);
        dart.as(value, V);
        this[_base$0][dartx.set](key, value);
        return value;
      }
      addAll(other) {
        dart.as(other, core.Map$(K, V));
        this[_base$0][dartx.addAll](other);
      }
      clear() {
        this[_base$0][dartx.clear]();
      }
      containsKey(key) {
        return this[_base$0][dartx.containsKey](key);
      }
      containsValue(value) {
        return this[_base$0][dartx.containsValue](value);
      }
      forEach(f) {
        dart.as(f, dart.functionType(dart.void, [K, V]));
        this[_base$0][dartx.forEach](f);
      }
      get isEmpty() {
        return this[_base$0][dartx.isEmpty];
      }
      get isNotEmpty() {
        return this[_base$0][dartx.isNotEmpty];
      }
      get keys() {
        return this[_base$0][dartx.keys];
      }
      get length() {
        return this[_base$0][dartx.length];
      }
      putIfAbsent(key, ifAbsent) {
        dart.as(key, K);
        dart.as(ifAbsent, dart.functionType(V, []));
        return this[_base$0][dartx.putIfAbsent](key, ifAbsent);
      }
      remove(key) {
        return this[_base$0][dartx.remove](key);
      }
      get values() {
        return this[_base$0][dartx.values];
      }
      toString() {
        return dart.toString(this[_base$0]);
      }
    }
    DelegatingMap[dart.implements] = () => [core.Map$(K, V)];
    dart.setSignature(DelegatingMap, {
      constructors: () => ({DelegatingMap: [wrappers.DelegatingMap$(K, V), [core.Map$(K, V)]]}),
      methods: () => ({
        get: [V, [core.Object]],
        set: [dart.void, [K, V]],
        addAll: [dart.void, [core.Map$(K, V)]],
        clear: [dart.void, []],
        containsKey: [core.bool, [core.Object]],
        containsValue: [core.bool, [core.Object]],
        forEach: [dart.void, [dart.functionType(dart.void, [K, V])]],
        putIfAbsent: [V, [K, dart.functionType(V, [])]],
        remove: [V, [core.Object]]
      }),
      statics: () => ({typed: [core.Map, [core.Map]]}),
      names: ['typed']
    });
    dart.defineExtensionMembers(DelegatingMap, [
      'get',
      'set',
      'addAll',
      'clear',
      'containsKey',
      'containsValue',
      'forEach',
      'putIfAbsent',
      'remove',
      'isEmpty',
      'isNotEmpty',
      'keys',
      'length',
      'values'
    ]);
    return DelegatingMap;
  });
  wrappers.DelegatingMap = wrappers.DelegatingMap$();
  collection$.DelegatingMap$ = wrappers.DelegatingMap$;
  collection$.DelegatingMap = wrappers.DelegatingMap;
  algorithms._reverse = function(list, start, end) {
    for (let i = start, j = dart.notNull(end) - 1; dart.notNull(i) < j; i = dart.notNull(i) + 1, j--) {
      let tmp = list[dartx.get](i);
      list[dartx.set](i, list[dartx.get](j));
      list[dartx.set](j, tmp);
    }
  };
  dart.fn(algorithms._reverse, dart.void, [core.List, core.int, core.int]);
  algorithms._MERGE_SORT_LIMIT = 32;
  algorithms._movingInsertionSort = function(list, compare, start, end, target, targetOffset) {
    let length = dart.notNull(end) - dart.notNull(start);
    if (length == 0) return;
    target[dartx.set](targetOffset, list[dartx.get](start));
    for (let i = 1; i < length; i++) {
      let element = list[dartx.get](dart.notNull(start) + i);
      let min = targetOffset;
      let max = dart.notNull(targetOffset) + i;
      while (dart.notNull(min) < max) {
        let mid = dart.notNull(min) + (max - dart.notNull(min) >> 1);
        if (dart.notNull(compare(element, target[dartx.get](mid))) < 0) {
          max = mid;
        } else {
          min = mid + 1;
        }
      }
      target[dartx.setRange](dart.notNull(min) + 1, dart.notNull(targetOffset) + i + 1, target, min);
      target[dartx.set](min, element);
    }
  };
  dart.fn(algorithms._movingInsertionSort, dart.void, [core.List, dart.functionType(core.int, [dart.dynamic, dart.dynamic]), core.int, core.int, core.List, core.int]);
  algorithms._mergeSort = function(list, compare, start, end, target, targetOffset) {
    let length = dart.notNull(end) - dart.notNull(start);
    if (length < dart.notNull(algorithms._MERGE_SORT_LIMIT)) {
      algorithms._movingInsertionSort(list, compare, start, end, target, targetOffset);
      return;
    }
    let middle = dart.notNull(start) + (length >> 1);
    let firstLength = middle - dart.notNull(start);
    let secondLength = dart.notNull(end) - middle;
    let targetMiddle = dart.notNull(targetOffset) + firstLength;
    algorithms._mergeSort(list, compare, middle, end, target, targetMiddle);
    algorithms._mergeSort(list, compare, start, middle, list, middle);
    algorithms._merge(compare, list, middle, middle + firstLength, target, targetMiddle, targetMiddle + secondLength, target, targetOffset);
  };
  dart.fn(algorithms._mergeSort, dart.void, [core.List, dart.functionType(core.int, [dart.dynamic, dart.dynamic]), core.int, core.int, core.List, core.int]);
  algorithms._merge = function(compare, firstList, firstStart, firstEnd, secondList, secondStart, secondEnd, target, targetOffset) {
    dart.assert(dart.notNull(firstStart) < dart.notNull(firstEnd));
    dart.assert(dart.notNull(secondStart) < dart.notNull(secondEnd));
    let cursor1 = firstStart;
    let cursor2 = secondStart;
    let firstElement = firstList[dartx.get]((() => {
      let x = cursor1;
      cursor1 = dart.notNull(x) + 1;
      return x;
    })());
    let secondElement = secondList[dartx.get]((() => {
      let x = cursor2;
      cursor2 = dart.notNull(x) + 1;
      return x;
    })());
    while (true) {
      if (dart.notNull(compare(firstElement, secondElement)) <= 0) {
        target[dartx.set]((() => {
          let x = targetOffset;
          targetOffset = dart.notNull(x) + 1;
          return x;
        })(), firstElement);
        if (cursor1 == firstEnd) break;
        firstElement = firstList[dartx.get]((() => {
          let x = cursor1;
          cursor1 = dart.notNull(x) + 1;
          return x;
        })());
      } else {
        target[dartx.set]((() => {
          let x = targetOffset;
          targetOffset = dart.notNull(x) + 1;
          return x;
        })(), secondElement);
        if (cursor2 != secondEnd) {
          secondElement = secondList[dartx.get]((() => {
            let x = cursor2;
            cursor2 = dart.notNull(x) + 1;
            return x;
          })());
          continue;
        }
        target[dartx.set]((() => {
          let x = targetOffset;
          targetOffset = dart.notNull(x) + 1;
          return x;
        })(), firstElement);
        target[dartx.setRange](targetOffset, dart.notNull(targetOffset) + (dart.notNull(firstEnd) - dart.notNull(cursor1)), firstList, cursor1);
        return;
      }
    }
    target[dartx.set]((() => {
      let x = targetOffset;
      targetOffset = dart.notNull(x) + 1;
      return x;
    })(), secondElement);
    target[dartx.setRange](targetOffset, dart.notNull(targetOffset) + (dart.notNull(secondEnd) - dart.notNull(cursor2)), secondList, cursor2);
  };
  dart.fn(algorithms._merge, dart.void, [dart.functionType(core.int, [dart.dynamic, dart.dynamic]), core.List, core.int, core.int, core.List, core.int, core.int, core.List, core.int]);
  utils.Pair$ = dart.generic((E, F) => {
    class Pair extends core.Object {
      Pair(first, last) {
        this.first = first;
        this.last = last;
      }
    }
    dart.setSignature(Pair, {
      constructors: () => ({Pair: [utils.Pair$(E, F), [E, F]]})
    });
    return Pair;
  });
  utils.Pair = utils.Pair$();
  utils.defaultCompare = function() {
    return dart.fn((value1, value2) => dart.as(value1, core.Comparable)[dartx.compareTo](value2), core.int, [dart.dynamic, dart.dynamic]);
  };
  dart.fn(utils.defaultCompare, core.Comparator, []);
  canonicalized_map._Canonicalize$ = dart.generic((C, K) => {
    const _Canonicalize = dart.typedef('_Canonicalize', () => dart.functionType(C, [K]));
    return _Canonicalize;
  });
  canonicalized_map._Canonicalize = canonicalized_map._Canonicalize$();
  canonicalized_map._IsValidKey = dart.typedef('_IsValidKey', () => dart.functionType(core.bool, [core.Object]));
  comparators._zero = 48;
  comparators._upperCaseA = 65;
  comparators._upperCaseZ = 90;
  comparators._lowerCaseA = 97;
  comparators._lowerCaseZ = 122;
  comparators._asciiCaseBit = 32;
  comparators._compareNaturally = function(a, b, index, aChar, bChar) {
    dart.assert(aChar != bChar);
    let aIsDigit = comparators._isDigit(aChar);
    let bIsDigit = comparators._isDigit(bChar);
    if (dart.notNull(aIsDigit)) {
      if (dart.notNull(bIsDigit)) {
        return comparators._compareNumerically(a, b, aChar, bChar, index);
      } else if (dart.notNull(index) > 0 && dart.notNull(comparators._isDigit(a[dartx.codeUnitAt](dart.notNull(index) - 1)))) {
        return 1;
      }
    } else if (dart.notNull(bIsDigit) && dart.notNull(index) > 0 && dart.notNull(comparators._isDigit(b[dartx.codeUnitAt](dart.notNull(index) - 1)))) {
      return -1;
    }
    return (dart.notNull(aChar) - dart.notNull(bChar))[dartx.sign];
  };
  dart.fn(comparators._compareNaturally, core.int, [core.String, core.String, core.int, core.int, core.int]);
  comparators._compareNumerically = function(a, b, aChar, bChar, index) {
    if (dart.notNull(comparators._isNonZeroNumberSuffix(a, index))) {
      let result = comparators._compareDigitCount(a, b, index, index);
      if (result != 0) return result;
      return (dart.notNull(aChar) - dart.notNull(bChar))[dartx.sign];
    }
    let aIndex = index;
    let bIndex = index;
    if (aChar == comparators._zero) {
      do {
        aIndex = dart.notNull(aIndex) + 1;
        if (aIndex == a[dartx.length]) return -1;
        aChar = a[dartx.codeUnitAt](aIndex);
      } while (aChar == comparators._zero);
      if (!dart.notNull(comparators._isDigit(aChar))) return -1;
    } else if (bChar == comparators._zero) {
      do {
        bIndex = dart.notNull(bIndex) + 1;
        if (bIndex == b[dartx.length]) return 1;
        bChar = b[dartx.codeUnitAt](bIndex);
      } while (bChar == comparators._zero);
      if (!dart.notNull(comparators._isDigit(bChar))) return 1;
    }
    if (aChar != bChar) {
      let result = comparators._compareDigitCount(a, b, aIndex, bIndex);
      if (result != 0) return result;
      return (dart.notNull(aChar) - dart.notNull(bChar))[dartx.sign];
    }
    while (true) {
      let aIsDigit = false;
      let bIsDigit = false;
      aChar = 0;
      bChar = 0;
      if ((aIndex = dart.notNull(aIndex) + 1) < dart.notNull(a[dartx.length])) {
        aChar = a[dartx.codeUnitAt](aIndex);
        aIsDigit = comparators._isDigit(aChar);
      }
      if ((bIndex = dart.notNull(bIndex) + 1) < dart.notNull(b[dartx.length])) {
        bChar = b[dartx.codeUnitAt](bIndex);
        bIsDigit = comparators._isDigit(bChar);
      }
      if (dart.notNull(aIsDigit)) {
        if (dart.notNull(bIsDigit)) {
          if (aChar == bChar) continue;
          break;
        }
        return 1;
      } else if (dart.notNull(bIsDigit)) {
        return -1;
      } else {
        return (dart.notNull(aIndex) - dart.notNull(bIndex))[dartx.sign];
      }
    }
    let result = comparators._compareDigitCount(a, b, aIndex, bIndex);
    if (result != 0) return result;
    return (dart.notNull(aChar) - dart.notNull(bChar))[dartx.sign];
  };
  dart.fn(comparators._compareNumerically, core.int, [core.String, core.String, core.int, core.int, core.int]);
  comparators._compareDigitCount = function(a, b, i, j) {
    while ((i = dart.notNull(i) + 1) < dart.notNull(a[dartx.length])) {
      let aIsDigit = comparators._isDigit(a[dartx.codeUnitAt](i));
      if ((j = dart.notNull(j) + 1) == b[dartx.length]) return dart.notNull(aIsDigit) ? 1 : 0;
      let bIsDigit = comparators._isDigit(b[dartx.codeUnitAt](j));
      if (dart.notNull(aIsDigit)) {
        if (dart.notNull(bIsDigit)) continue;
        return 1;
      } else if (dart.notNull(bIsDigit)) {
        return -1;
      } else {
        return 0;
      }
    }
    if ((j = dart.notNull(j) + 1) < dart.notNull(b[dartx.length]) && dart.notNull(comparators._isDigit(b[dartx.codeUnitAt](j)))) {
      return -1;
    }
    return 0;
  };
  dart.fn(comparators._compareDigitCount, core.int, [core.String, core.String, core.int, core.int]);
  comparators._isDigit = function(charCode) {
    return (dart.notNull(charCode) ^ dart.notNull(comparators._zero)) <= 9;
  };
  dart.fn(comparators._isDigit, core.bool, [core.int]);
  comparators._isNonZeroNumberSuffix = function(string, index) {
    while ((index = dart.notNull(index) - 1) >= 0) {
      let char = string[dartx.codeUnitAt](index);
      if (char != comparators._zero) return comparators._isDigit(char);
    }
    return false;
  };
  dart.fn(comparators._isNonZeroNumberSuffix, core.bool, [core.String, core.int]);
  equality._HASH_MASK = 2147483647;
  equality._MapEntry = class _MapEntry extends core.Object {
    _MapEntry(equality, key, value) {
      this.equality = equality;
      this.key = key;
      this.value = value;
    }
    get hashCode() {
      return 3 * dart.notNull(this.equality[_keyEquality].hash(this.key)) + 7 * dart.notNull(this.equality[_valueEquality].hash(this.value)) & dart.notNull(equality._HASH_MASK);
    }
    ['=='](other) {
      if (!dart.is(other, equality._MapEntry)) return false;
      let otherEntry = dart.as(other, equality._MapEntry);
      return dart.notNull(this.equality[_keyEquality].equals(this.key, otherEntry.key)) && dart.notNull(this.equality[_valueEquality].equals(this.value, otherEntry.value));
    }
  };
  dart.setSignature(equality._MapEntry, {
    constructors: () => ({_MapEntry: [equality._MapEntry, [equality.MapEquality, dart.dynamic, dart.dynamic]]}),
    methods: () => ({'==': [core.bool, [core.Object]]})
  });
  const _iterators = Symbol('_iterators');
  const _current = Symbol('_current');
  iterable_zip._IteratorZip$ = dart.generic(T => {
    class _IteratorZip extends core.Object {
      _IteratorZip(iterators) {
        this[_iterators] = iterators;
        this[_current] = null;
      }
      moveNext() {
        if (dart.notNull(this[_iterators][dartx.isEmpty])) return false;
        for (let i = 0; i < dart.notNull(this[_iterators][dartx.length]); i++) {
          if (!dart.notNull(this[_iterators][dartx.get](i).moveNext())) {
            this[_current] = null;
            return false;
          }
        }
        this[_current] = core.List$(T).new(this[_iterators][dartx.length]);
        for (let i = 0; i < dart.notNull(this[_iterators][dartx.length]); i++) {
          this[_current][dartx.set](i, this[_iterators][dartx.get](i).current);
        }
        return true;
      }
      get current() {
        return this[_current];
      }
    }
    _IteratorZip[dart.implements] = () => [core.Iterator$(core.List$(T))];
    dart.setSignature(_IteratorZip, {
      constructors: () => ({_IteratorZip: [iterable_zip._IteratorZip$(T), [core.List$(core.Iterator$(T))]]}),
      methods: () => ({moveNext: [core.bool, []]})
    });
    return _IteratorZip;
  });
  iterable_zip._IteratorZip = iterable_zip._IteratorZip$();
  unmodifiable_wrappers.UnmodifiableMapView$ = collection.UnmodifiableMapView$;
  unmodifiable_wrappers.UnmodifiableMapView = collection.UnmodifiableMapView;
  unmodifiable_wrappers.UnmodifiableListView$ = collection.UnmodifiableListView$;
  unmodifiable_wrappers.UnmodifiableListView = collection.UnmodifiableListView;
  wrappers._KeyForValue$ = dart.generic((K, V) => {
    const _KeyForValue = dart.typedef('_KeyForValue', () => dart.functionType(K, [V]));
    return _KeyForValue;
  });
  wrappers._KeyForValue = wrappers._KeyForValue$();
  typed_wrappers._UnaryFunction$ = dart.generic((E, F) => {
    const _UnaryFunction = dart.typedef('_UnaryFunction', () => dart.functionType(F, [E]));
    return _UnaryFunction;
  });
  typed_wrappers._UnaryFunction = typed_wrappers._UnaryFunction$();
  const _base$1 = Symbol('_base');
  const _validate = Symbol('_validate');
  typed_wrappers._TypeSafeIterableBase$ = dart.generic(E => {
    class _TypeSafeIterableBase extends core.Object {
      _TypeSafeIterableBase() {
      }
      any(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$1][dartx.any](this[_validate](test));
      }
      contains(element) {
        return this[_base$1][dartx.contains](element);
      }
      elementAt(index) {
        return dart.as(this[_base$1][dartx.elementAt](index), E);
      }
      every(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return this[_base$1][dartx.every](this[_validate](test));
      }
      expand(f) {
        dart.as(f, dart.functionType(core.Iterable, [E]));
        return this[_base$1][dartx.expand](this[_validate](f));
      }
      get first() {
        return dart.as(this[_base$1][dartx.first], E);
      }
      firstWhere(test, opts) {
        dart.as(test, dart.functionType(core.bool, [E]));
        let orElse = opts && 'orElse' in opts ? opts.orElse : null;
        dart.as(orElse, dart.functionType(E, []));
        return dart.as(this[_base$1][dartx.firstWhere](this[_validate](test), {orElse: orElse}), E);
      }
      fold(initialValue, combine) {
        dart.as(combine, dart.functionType(dart.dynamic, [dart.dynamic, E]));
        return this[_base$1][dartx.fold](initialValue, dart.fn((previousValue, element) => combine(previousValue, dart.as(element, E)), dart.dynamic, [dart.dynamic, dart.dynamic]));
      }
      forEach(f) {
        dart.as(f, dart.functionType(dart.void, [E]));
        return this[_base$1][dartx.forEach](this[_validate](f));
      }
      get isEmpty() {
        return this[_base$1][dartx.isEmpty];
      }
      get isNotEmpty() {
        return this[_base$1][dartx.isNotEmpty];
      }
      get iterator() {
        return this[_base$1][dartx.map](dart.fn(element => dart.as(element, E), E, [dart.dynamic]))[dartx.iterator];
      }
      [Symbol.iterator]() {
        return new dart.JsIterator(this.iterator);
      }
      join(separator) {
        if (separator === void 0) separator = "";
        return this[_base$1][dartx.join](separator);
      }
      get last() {
        return dart.as(this[_base$1][dartx.last], E);
      }
      lastWhere(test, opts) {
        dart.as(test, dart.functionType(core.bool, [E]));
        let orElse = opts && 'orElse' in opts ? opts.orElse : null;
        dart.as(orElse, dart.functionType(E, []));
        return dart.as(this[_base$1][dartx.lastWhere](this[_validate](test), {orElse: orElse}), E);
      }
      get length() {
        return this[_base$1][dartx.length];
      }
      map(f) {
        dart.as(f, dart.functionType(dart.dynamic, [E]));
        return this[_base$1][dartx.map](this[_validate](f));
      }
      reduce(combine) {
        dart.as(combine, dart.functionType(E, [E, E]));
        return dart.as(this[_base$1][dartx.reduce](dart.fn((value, element) => combine(dart.as(value, E), dart.as(element, E)), E, [dart.dynamic, dart.dynamic])), E);
      }
      get single() {
        return dart.as(this[_base$1][dartx.single], E);
      }
      singleWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return dart.as(this[_base$1][dartx.singleWhere](this[_validate](test)), E);
      }
      skip(n) {
        return new (typed_wrappers.TypeSafeIterable$(E))(this[_base$1][dartx.skip](n));
      }
      skipWhile(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return new (typed_wrappers.TypeSafeIterable$(E))(this[_base$1][dartx.skipWhile](this[_validate](test)));
      }
      take(n) {
        return new (typed_wrappers.TypeSafeIterable$(E))(this[_base$1][dartx.take](n));
      }
      takeWhile(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return new (typed_wrappers.TypeSafeIterable$(E))(this[_base$1][dartx.takeWhile](this[_validate](test)));
      }
      toList(opts) {
        let growable = opts && 'growable' in opts ? opts.growable : true;
        return new (typed_wrappers.TypeSafeList$(E))(this[_base$1][dartx.toList]({growable: growable}));
      }
      toSet() {
        return new (typed_wrappers.TypeSafeSet$(E))(this[_base$1][dartx.toSet]());
      }
      where(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        return new (typed_wrappers.TypeSafeIterable$(E))(this[_base$1][dartx.where](this[_validate](test)));
      }
      toString() {
        return dart.toString(this[_base$1]);
      }
      [_validate](func) {
        dart.as(func, dart.functionType(dart.dynamic, [E]));
        return dart.fn(value => func(dart.as(value, E)), dart.dynamic, [dart.dynamic]);
      }
    }
    _TypeSafeIterableBase[dart.implements] = () => [core.Iterable$(E)];
    dart.setSignature(_TypeSafeIterableBase, {
      constructors: () => ({_TypeSafeIterableBase: [typed_wrappers._TypeSafeIterableBase$(E), []]}),
      methods: () => ({
        any: [core.bool, [dart.functionType(core.bool, [E])]],
        contains: [core.bool, [core.Object]],
        elementAt: [E, [core.int]],
        every: [core.bool, [dart.functionType(core.bool, [E])]],
        expand: [core.Iterable, [dart.functionType(core.Iterable, [E])]],
        firstWhere: [E, [dart.functionType(core.bool, [E])], {orElse: dart.functionType(E, [])}],
        fold: [dart.dynamic, [dart.dynamic, dart.functionType(dart.dynamic, [dart.dynamic, E])]],
        forEach: [dart.void, [dart.functionType(dart.void, [E])]],
        join: [core.String, [], [core.String]],
        lastWhere: [E, [dart.functionType(core.bool, [E])], {orElse: dart.functionType(E, [])}],
        map: [core.Iterable, [dart.functionType(dart.dynamic, [E])]],
        reduce: [E, [dart.functionType(E, [E, E])]],
        singleWhere: [E, [dart.functionType(core.bool, [E])]],
        skip: [core.Iterable$(E), [core.int]],
        skipWhile: [core.Iterable$(E), [dart.functionType(core.bool, [E])]],
        take: [core.Iterable$(E), [core.int]],
        takeWhile: [core.Iterable$(E), [dart.functionType(core.bool, [E])]],
        toList: [core.List$(E), [], {growable: core.bool}],
        toSet: [core.Set$(E), []],
        where: [core.Iterable$(E), [dart.functionType(core.bool, [E])]],
        [_validate]: [typed_wrappers._UnaryFunction, [dart.functionType(dart.dynamic, [E])]]
      })
    });
    dart.defineExtensionMembers(_TypeSafeIterableBase, [
      'any',
      'contains',
      'elementAt',
      'every',
      'expand',
      'firstWhere',
      'fold',
      'forEach',
      'join',
      'lastWhere',
      'map',
      'reduce',
      'singleWhere',
      'skip',
      'skipWhile',
      'take',
      'takeWhile',
      'toList',
      'toSet',
      'where',
      'toString',
      'first',
      'isEmpty',
      'isNotEmpty',
      'iterator',
      'last',
      'length',
      'single'
    ]);
    return _TypeSafeIterableBase;
  });
  typed_wrappers._TypeSafeIterableBase = typed_wrappers._TypeSafeIterableBase$();
  typed_wrappers.TypeSafeIterable$ = dart.generic(E => {
    class TypeSafeIterable extends typed_wrappers._TypeSafeIterableBase$(E) {
      TypeSafeIterable(base) {
        this[_base$1] = base;
        super._TypeSafeIterableBase();
      }
    }
    TypeSafeIterable[dart.implements] = () => [wrappers.DelegatingIterable$(E)];
    dart.setSignature(TypeSafeIterable, {
      constructors: () => ({TypeSafeIterable: [typed_wrappers.TypeSafeIterable$(E), [core.Iterable]]})
    });
    return TypeSafeIterable;
  });
  typed_wrappers.TypeSafeIterable = typed_wrappers.TypeSafeIterable$();
  const _listBase$ = Symbol('_listBase');
  typed_wrappers.TypeSafeList$ = dart.generic(E => {
    class TypeSafeList extends typed_wrappers.TypeSafeIterable$(E) {
      TypeSafeList(base) {
        super.TypeSafeIterable(base);
      }
      get [_listBase$]() {
        return dart.as(this[_base$1], core.List);
      }
      get(index) {
        return dart.as(this[_listBase$][dartx.get](index), E);
      }
      set(index, value) {
        dart.as(value, E);
        this[_listBase$][dartx.set](index, value);
        return value;
      }
      add(value) {
        dart.as(value, E);
        this[_listBase$][dartx.add](value);
      }
      addAll(iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase$][dartx.addAll](iterable);
      }
      asMap() {
        return new (typed_wrappers.TypeSafeMap$(core.int, E))(this[_listBase$][dartx.asMap]());
      }
      clear() {
        this[_listBase$][dartx.clear]();
      }
      fillRange(start, end, fillValue) {
        if (fillValue === void 0) fillValue = null;
        dart.as(fillValue, E);
        this[_listBase$][dartx.fillRange](start, end, fillValue);
      }
      getRange(start, end) {
        return new (typed_wrappers.TypeSafeIterable$(E))(this[_listBase$][dartx.getRange](start, end));
      }
      indexOf(element, start) {
        dart.as(element, E);
        if (start === void 0) start = 0;
        return this[_listBase$][dartx.indexOf](element, start);
      }
      insert(index, element) {
        dart.as(element, E);
        this[_listBase$][dartx.insert](index, element);
      }
      insertAll(index, iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase$][dartx.insertAll](index, iterable);
      }
      lastIndexOf(element, start) {
        dart.as(element, E);
        if (start === void 0) start = null;
        return this[_listBase$][dartx.lastIndexOf](element, start);
      }
      set length(newLength) {
        this[_listBase$][dartx.length] = newLength;
      }
      remove(value) {
        return this[_listBase$][dartx.remove](value);
      }
      removeAt(index) {
        return dart.as(this[_listBase$][dartx.removeAt](index), E);
      }
      removeLast() {
        return dart.as(this[_listBase$][dartx.removeLast](), E);
      }
      removeRange(start, end) {
        this[_listBase$][dartx.removeRange](start, end);
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_listBase$][dartx.removeWhere](this[_validate](test));
      }
      replaceRange(start, end, iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase$][dartx.replaceRange](start, end, iterable);
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_listBase$][dartx.retainWhere](this[_validate](test));
      }
      get reversed() {
        return new (typed_wrappers.TypeSafeIterable$(E))(this[_listBase$][dartx.reversed]);
      }
      setAll(index, iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_listBase$][dartx.setAll](index, iterable);
      }
      setRange(start, end, iterable, skipCount) {
        dart.as(iterable, core.Iterable$(E));
        if (skipCount === void 0) skipCount = 0;
        this[_listBase$][dartx.setRange](start, end, iterable, skipCount);
      }
      shuffle(random) {
        if (random === void 0) random = null;
        this[_listBase$][dartx.shuffle](random);
      }
      sort(compare) {
        if (compare === void 0) compare = null;
        dart.as(compare, dart.functionType(core.int, [E, E]));
        if (compare == null) {
          this[_listBase$][dartx.sort]();
        } else {
          this[_listBase$][dartx.sort](dart.fn((a, b) => compare(dart.as(a, E), dart.as(b, E)), core.int, [dart.dynamic, dart.dynamic]));
        }
      }
      sublist(start, end) {
        if (end === void 0) end = null;
        return new (typed_wrappers.TypeSafeList$(E))(this[_listBase$][dartx.sublist](start, end));
      }
    }
    TypeSafeList[dart.implements] = () => [wrappers.DelegatingList$(E)];
    dart.setSignature(TypeSafeList, {
      constructors: () => ({TypeSafeList: [typed_wrappers.TypeSafeList$(E), [core.List]]}),
      methods: () => ({
        get: [E, [core.int]],
        set: [dart.void, [core.int, E]],
        add: [dart.void, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        asMap: [core.Map$(core.int, E), []],
        clear: [dart.void, []],
        fillRange: [dart.void, [core.int, core.int], [E]],
        getRange: [core.Iterable$(E), [core.int, core.int]],
        indexOf: [core.int, [E], [core.int]],
        insert: [dart.void, [core.int, E]],
        insertAll: [dart.void, [core.int, core.Iterable$(E)]],
        lastIndexOf: [core.int, [E], [core.int]],
        remove: [core.bool, [core.Object]],
        removeAt: [E, [core.int]],
        removeLast: [E, []],
        removeRange: [dart.void, [core.int, core.int]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        replaceRange: [dart.void, [core.int, core.int, core.Iterable$(E)]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        setAll: [dart.void, [core.int, core.Iterable$(E)]],
        setRange: [dart.void, [core.int, core.int, core.Iterable$(E)], [core.int]],
        shuffle: [dart.void, [], [math.Random]],
        sort: [dart.void, [], [dart.functionType(core.int, [E, E])]],
        sublist: [core.List$(E), [core.int], [core.int]]
      })
    });
    dart.defineExtensionMembers(TypeSafeList, [
      'get',
      'set',
      'add',
      'addAll',
      'asMap',
      'clear',
      'fillRange',
      'getRange',
      'indexOf',
      'insert',
      'insertAll',
      'lastIndexOf',
      'remove',
      'removeAt',
      'removeLast',
      'removeRange',
      'removeWhere',
      'replaceRange',
      'retainWhere',
      'setAll',
      'setRange',
      'shuffle',
      'sort',
      'sublist',
      'length',
      'reversed'
    ]);
    return TypeSafeList;
  });
  typed_wrappers.TypeSafeList = typed_wrappers.TypeSafeList$();
  const _setBase$ = Symbol('_setBase');
  typed_wrappers.TypeSafeSet$ = dart.generic(E => {
    class TypeSafeSet extends typed_wrappers.TypeSafeIterable$(E) {
      TypeSafeSet(base) {
        super.TypeSafeIterable(base);
      }
      get [_setBase$]() {
        return dart.as(this[_base$1], core.Set);
      }
      add(value) {
        dart.as(value, E);
        return this[_setBase$].add(value);
      }
      addAll(elements) {
        dart.as(elements, core.Iterable$(E));
        this[_setBase$].addAll(elements);
      }
      clear() {
        this[_setBase$].clear();
      }
      containsAll(other) {
        return this[_setBase$].containsAll(other);
      }
      difference(other) {
        dart.as(other, core.Set$(E));
        return new (typed_wrappers.TypeSafeSet$(E))(this[_setBase$].difference(other));
      }
      intersection(other) {
        return new (typed_wrappers.TypeSafeSet$(E))(this[_setBase$].intersection(other));
      }
      lookup(element) {
        return dart.as(this[_setBase$].lookup(element), E);
      }
      remove(value) {
        return this[_setBase$].remove(value);
      }
      removeAll(elements) {
        this[_setBase$].removeAll(elements);
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_setBase$].removeWhere(this[_validate](test));
      }
      retainAll(elements) {
        this[_setBase$].retainAll(elements);
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_setBase$].retainWhere(this[_validate](test));
      }
      union(other) {
        dart.as(other, core.Set$(E));
        return new (typed_wrappers.TypeSafeSet$(E))(this[_setBase$].union(other));
      }
    }
    TypeSafeSet[dart.implements] = () => [wrappers.DelegatingSet$(E)];
    dart.setSignature(TypeSafeSet, {
      constructors: () => ({TypeSafeSet: [typed_wrappers.TypeSafeSet$(E), [core.Set]]}),
      methods: () => ({
        add: [core.bool, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        clear: [dart.void, []],
        containsAll: [core.bool, [core.Iterable$(core.Object)]],
        difference: [core.Set$(E), [core.Set$(E)]],
        intersection: [core.Set$(E), [core.Set$(core.Object)]],
        lookup: [E, [core.Object]],
        remove: [core.bool, [core.Object]],
        removeAll: [dart.void, [core.Iterable$(core.Object)]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        retainAll: [dart.void, [core.Iterable$(core.Object)]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        union: [core.Set$(E), [core.Set$(E)]]
      })
    });
    return TypeSafeSet;
  });
  typed_wrappers.TypeSafeSet = typed_wrappers.TypeSafeSet$();
  const _baseQueue$ = Symbol('_baseQueue');
  typed_wrappers.TypeSafeQueue$ = dart.generic(E => {
    class TypeSafeQueue extends typed_wrappers.TypeSafeIterable$(E) {
      TypeSafeQueue(queue) {
        super.TypeSafeIterable(queue);
      }
      get [_baseQueue$]() {
        return dart.as(this[_base$1], collection.Queue);
      }
      add(value) {
        dart.as(value, E);
        this[_baseQueue$].add(value);
      }
      addAll(iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_baseQueue$].addAll(iterable);
      }
      addFirst(value) {
        dart.as(value, E);
        this[_baseQueue$].addFirst(value);
      }
      addLast(value) {
        dart.as(value, E);
        this[_baseQueue$].addLast(value);
      }
      clear() {
        this[_baseQueue$].clear();
      }
      remove(object) {
        return this[_baseQueue$].remove(object);
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_baseQueue$].removeWhere(this[_validate](test));
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        this[_baseQueue$].retainWhere(this[_validate](test));
      }
      removeFirst() {
        return dart.as(this[_baseQueue$].removeFirst(), E);
      }
      removeLast() {
        return dart.as(this[_baseQueue$].removeLast(), E);
      }
    }
    TypeSafeQueue[dart.implements] = () => [wrappers.DelegatingQueue$(E)];
    dart.setSignature(TypeSafeQueue, {
      constructors: () => ({TypeSafeQueue: [typed_wrappers.TypeSafeQueue$(E), [collection.Queue]]}),
      methods: () => ({
        add: [dart.void, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        addFirst: [dart.void, [E]],
        addLast: [dart.void, [E]],
        clear: [dart.void, []],
        remove: [core.bool, [core.Object]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        removeFirst: [E, []],
        removeLast: [E, []]
      })
    });
    return TypeSafeQueue;
  });
  typed_wrappers.TypeSafeQueue = typed_wrappers.TypeSafeQueue$();
  typed_wrappers.TypeSafeMap$ = dart.generic((K, V) => {
    class TypeSafeMap extends core.Object {
      TypeSafeMap(base) {
        this[_base$1] = base;
      }
      get(key) {
        return dart.as(this[_base$1][dartx.get](key), V);
      }
      set(key, value) {
        dart.as(key, K);
        dart.as(value, V);
        this[_base$1][dartx.set](key, value);
        return value;
      }
      addAll(other) {
        dart.as(other, core.Map$(K, V));
        this[_base$1][dartx.addAll](other);
      }
      clear() {
        this[_base$1][dartx.clear]();
      }
      containsKey(key) {
        return this[_base$1][dartx.containsKey](key);
      }
      containsValue(value) {
        return this[_base$1][dartx.containsValue](value);
      }
      forEach(f) {
        dart.as(f, dart.functionType(dart.void, [K, V]));
        this[_base$1][dartx.forEach](dart.fn((key, value) => f(dart.as(key, K), dart.as(value, V)), dart.void, [dart.dynamic, dart.dynamic]));
      }
      get isEmpty() {
        return this[_base$1][dartx.isEmpty];
      }
      get isNotEmpty() {
        return this[_base$1][dartx.isNotEmpty];
      }
      get keys() {
        return new (typed_wrappers.TypeSafeIterable$(K))(this[_base$1][dartx.keys]);
      }
      get length() {
        return this[_base$1][dartx.length];
      }
      putIfAbsent(key, ifAbsent) {
        dart.as(key, K);
        dart.as(ifAbsent, dart.functionType(V, []));
        return dart.as(this[_base$1][dartx.putIfAbsent](key, ifAbsent), V);
      }
      remove(key) {
        return dart.as(this[_base$1][dartx.remove](key), V);
      }
      get values() {
        return new (typed_wrappers.TypeSafeIterable$(V))(this[_base$1][dartx.values]);
      }
      toString() {
        return dart.toString(this[_base$1]);
      }
    }
    TypeSafeMap[dart.implements] = () => [wrappers.DelegatingMap$(K, V)];
    dart.setSignature(TypeSafeMap, {
      constructors: () => ({TypeSafeMap: [typed_wrappers.TypeSafeMap$(K, V), [core.Map]]}),
      methods: () => ({
        get: [V, [core.Object]],
        set: [dart.void, [K, V]],
        addAll: [dart.void, [core.Map$(K, V)]],
        clear: [dart.void, []],
        containsKey: [core.bool, [core.Object]],
        containsValue: [core.bool, [core.Object]],
        forEach: [dart.void, [dart.functionType(dart.void, [K, V])]],
        putIfAbsent: [V, [K, dart.functionType(V, [])]],
        remove: [V, [core.Object]]
      })
    });
    dart.defineExtensionMembers(TypeSafeMap, [
      'get',
      'set',
      'addAll',
      'clear',
      'containsKey',
      'containsValue',
      'forEach',
      'putIfAbsent',
      'remove',
      'isEmpty',
      'isNotEmpty',
      'keys',
      'length',
      'values'
    ]);
    return TypeSafeMap;
  });
  typed_wrappers.TypeSafeMap = typed_wrappers.TypeSafeMap$();
  // Exports:
  exports.collection = collection$;
  exports.algorithms = algorithms;
  exports.utils = utils;
  exports.canonicalized_map = canonicalized_map;
  exports.comparators = comparators;
  exports.equality = equality;
  exports.iterable_zip = iterable_zip;
  exports.priority_queue = priority_queue;
  exports.queue_list = queue_list;
  exports.unmodifiable_wrappers = unmodifiable_wrappers;
  exports.wrappers = wrappers;
  exports.typed_wrappers = typed_wrappers;
});

//# sourceMappingURL=collection.js.map
